JUCE: Component Class Reference

JUCE

Classes | Public Types | Public Member Functions | Static Public Member Functions | List of all members
Component Class Reference

The base class for all JUCE user-interface objects. More...

Inherits MouseListener.

Inherited by ActiveXControlComponent, AndroidViewComponent, AnimatedAppComponent, AudioAppComponent, AudioDeviceSelectorComponent, AudioProcessorEditor, AudioVisualiserComponent, BubbleComponent, BurgerMenuComponent, Button, CallOutBox, CaretComponent, CodeEditorComponent, ColourSelector, ComboBox, ConcertinaPanel, Drawable, FileBrowserComponent, FilenameComponent, FilePreviewComponent, FileSearchPathListComponent, GroupComponent, ImageComponent, JUCESplashScreen, KeyMappingEditorComponent, Label, LassoComponent< SelectableItemType >, ListBox, MenuBarComponent, MidiKeyboardComponent, MultiDocumentPanel, NSViewComponent, OnlineUnlockForm, OpenGLAppComponent, PluginListComponent, PopupMenu::CustomComponent, PreferencesPanel, ProgressBar, PropertyComponent, PropertyPanel, ResizableBorderComponent, ResizableCornerComponent, ResizableEdgeComponent, ScrollBar, SidePanel, Slider, SplashScreen, StretchableLayoutResizerBar, SystemTrayIconComponent, TabbedButtonBar, TabbedComponent, TableHeaderComponent, TextEditor, Toolbar, ToolbarItemPalette, TooltipWindow, TopLevelWindow, TreeView, UIViewComponent, VideoComponent, Viewport, WebBrowserComponent, and XEmbedComponent.

## Classes
class | BailOutChecker
| A class to keep an eye on a component and check for it being deleted. More...
class | Positioner
| Base class for objects that can be used to automatically position a component according to some kind of algorithm. More...
class | SafePointer
| Holds a pointer to some type of Component, which automatically becomes null if the component is deleted. More...

## Public Types
enum | FocusChangeType { focusChangedByMouseClick, focusChangedByTabKey, focusChangedDirectly }
| Enumeration used by the focusGained() and focusLost() methods. More...

## Public Member Functions
| Component () noexcept
| Creates a component. More...
| ~Component () override
| Destructor. More...
| Component (const String &componentName) noexcept
| Creates a component, setting its name at the same time. More...
const String & | getName () const noexcept
| Returns the name of this component. More...
virtual void | setName (const String &newName)
| Sets the name of this component. More...
const String & | getComponentID () const noexcept
| Returns the ID string that was set by setComponentID(). More...
void | setComponentID (const String &newID)
| Sets the component's ID string. More...
virtual void | setVisible (bool shouldBeVisible)
| Makes the component visible or invisible. More...
bool | isVisible () const noexcept
| Tests whether the component is visible or not. More...
virtual void | visibilityChanged ()
| Called when this component's visibility changes. More...
bool | isShowing () const
| Tests whether this component and all its parents are visible. More...
virtual void | addToDesktop (int windowStyleFlags, void *nativeWindowToAttachTo=nullptr)
| Makes this component appear as a window on the desktop. More...
void | removeFromDesktop ()
| If the component is currently showing on the desktop, this will hide it. More...
bool | isOnDesktop () const noexcept
| Returns true if this component is currently showing on the desktop. More...
ComponentPeer * | getPeer () const
| Returns the heavyweight window that contains this component. More...
virtual void | userTriedToCloseWindow ()
| For components on the desktop, this is called if the system wants to close the window. More...
virtual void | minimisationStateChanged (bool isNowMinimised)
| Called for a desktop component which has just been minimised or un-minimised. More...
virtual float | getDesktopScaleFactor () const
| Returns the default scale factor to use for this component when it is placed on the desktop. More...
void | toFront (bool shouldAlsoGainFocus)
| Brings the component to the front of its siblings. More...
void | toBack ()
| Changes this component's z-order to be at the back of all its siblings. More...
void | toBehind (Component *other)
| Changes this component's z-order so that it's just behind another component. More...
void | setAlwaysOnTop (bool shouldStayOnTop)
| Sets whether the component should always be kept at the front of its siblings. More...
bool | isAlwaysOnTop () const noexcept
| Returns true if this component is set to always stay in front of its siblings. More...
int | getX () const noexcept
| Returns the x coordinate of the component's left edge. More...
int | getY () const noexcept
| Returns the y coordinate of the top of this component. More...
int | getWidth () const noexcept
| Returns the component's width in pixels. More...
int | getHeight () const noexcept
| Returns the component's height in pixels. More...
int | getRight () const noexcept
| Returns the x coordinate of the component's right-hand edge. More...
Point< int > | getPosition () const noexcept
| Returns the component's top-left position as a Point. More...
int | getBottom () const noexcept
| Returns the y coordinate of the bottom edge of this component. More...
Rectangle< int > | getBounds () const noexcept
| Returns this component's bounding box. More...
Rectangle< int > | getLocalBounds () const noexcept
| Returns the component's bounds, relative to its own origin. More...
Rectangle< int > | getBoundsInParent () const noexcept
| Returns the area of this component's parent which this component covers. More...
int | getScreenX () const
| Returns this component's x coordinate relative the screen's top-left origin. More...
int | getScreenY () const
| Returns this component's y coordinate relative the screen's top-left origin. More...
Point< int > | getScreenPosition () const
| Returns the position of this component's top-left corner relative to the screen's top-left. More...
Rectangle< int > | getScreenBounds () const
| Returns the bounds of this component, relative to the screen's top-left. More...
Point< int > | getLocalPoint (const Component *sourceComponent, Point< int > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space. More...
Point< float > | getLocalPoint (const Component *sourceComponent, Point< float > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space. More...
Rectangle< int > | getLocalArea (const Component *sourceComponent, Rectangle< int > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space. More...
Point< int > | localPointToGlobal (Point< int > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate. More...
Point< float > | localPointToGlobal (Point< float > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate. More...
Rectangle< int > | localAreaToGlobal (Rectangle< int > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate. More...
void | setTopLeftPosition (int x, int y)
| Moves the component to a new position. More...
void | setTopLeftPosition (Point< int > newTopLeftPosition)
| Moves the component to a new position. More...
void | setTopRightPosition (int x, int y)
| Moves the component to a new position. More...
void | setSize (int newWidth, int newHeight)
| Changes the size of the component. More...
void | setBounds (int x, int y, int width, int height)
| Changes the component's position and size. More...
void | setBounds (Rectangle< int > newBounds)
| Changes the component's position and size. More...
void | setBoundsRelative (float proportionalX, float proportionalY, float proportionalWidth, float proportionalHeight)
| Changes the component's position and size in terms of fractions of its parent's size. More...
void | setBoundsRelative (Rectangle< float > proportionalArea)
| Changes the component's position and size in terms of fractions of its parent's size. More...
void | setBoundsInset (BorderSize< int > borders)
| Changes the component's position and size based on the amount of space to leave around it. More...
void | setBoundsToFit (Rectangle< int > targetArea, Justification justification, bool onlyReduceInSize)
| Positions the component within a given rectangle, keeping its proportions unchanged. More...
void | setCentrePosition (int x, int y)
| Changes the position of the component's centre. More...
void | setCentrePosition (Point< int > newCentrePosition)
| Changes the position of the component's centre. More...
void | setCentreRelative (float x, float y)
| Changes the position of the component's centre. More...
void | centreWithSize (int width, int height)
| Changes the component's size and centres it within its parent. More...
void | setTransform (const AffineTransform &transform)
| Sets a transform matrix to be applied to this component. More...
AffineTransform | getTransform () const
| Returns the transform that is currently being applied to this component. More...
bool | isTransformed () const noexcept
| Returns true if a non-identity transform is being applied to this component. More...
int | proportionOfWidth (float proportion) const noexcept
| Returns a proportion of the component's width. More...
int | proportionOfHeight (float proportion) const noexcept
| Returns a proportion of the component's height. More...
int | getParentWidth () const noexcept
| Returns the width of the component's parent. More...
int | getParentHeight () const noexcept
| Returns the height of the component's parent. More...
Rectangle< int > | getParentMonitorArea () const
| Returns the screen coordinates of the monitor that contains this component. More...
int | getNumChildComponents () const noexcept
| Returns the number of child components that this component contains. More...
Component * | getChildComponent (int index) const noexcept
| Returns one of this component's child components, by it index. More...
int | getIndexOfChildComponent (const Component *child) const noexcept
| Returns the index of this component in the list of child components. More...
const Array< Component * > & | getChildren () const noexcept
| Provides access to the underlying array of child components. More...
Component * | findChildWithID (StringRef componentID) const noexcept
| Looks for a child component with the specified ID. More...
void | addChildComponent (Component *child, int zOrder=-1)
| Adds a child component to this one. More...
void | addChildComponent (Component &child, int zOrder=-1)
| Adds a child component to this one. More...
void | addAndMakeVisible (Component *child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already. More...
void | addAndMakeVisible (Component &child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already. More...
void | addChildAndSetID (Component *child, const String &componentID)
| Adds a child component to this one, makes it visible, and sets its component ID. More...
void | removeChildComponent (Component *childToRemove)
| Removes one of this component's child-components. More...
Component * | removeChildComponent (int childIndexToRemove)
| Removes one of this component's child-components by index. More...
void | removeAllChildren ()
| Removes all this component's children. More...
void | deleteAllChildren ()
| Removes and deletes all of this component's children. More...
Component * | getParentComponent () const noexcept
| Returns the component which this component is inside. More...
template<class TargetClass >
TargetClass * | findParentComponentOfClass () const
| Searches the parent components for a component of a specified class. More...
Component * | getTopLevelComponent () const noexcept
| Returns the highest-level component which contains this one or its parents. More...
bool | isParentOf (const Component *possibleChild) const noexcept
| Checks whether a component is anywhere inside this component or its children. More...
virtual void | parentHierarchyChanged ()
| Called to indicate that the component's parents have changed. More...
virtual void | childrenChanged ()
| Subclasses can use this callback to be told when children are added or removed, or when their z-order changes. More...
virtual bool | hitTest (int x, int y)
| Tests whether a given point is inside the component. More...
void | setInterceptsMouseClicks (bool allowClicksOnThisComponent, bool allowClicksOnChildComponents) noexcept
| Changes the default return value for the hitTest() method. More...
void | getInterceptsMouseClicks (bool &allowsClicksOnThisComponent, bool &allowsClicksOnChildComponents) const noexcept
| Retrieves the current state of the mouse-click interception flags. More...
bool | contains (Point< int > localPoint)
| Returns true if a given point lies within this component or one of its children. More...
bool | reallyContains (Point< int > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account. More...
Component * | getComponentAt (int x, int y)
| Returns the component at a certain point within this one. More...
Component * | getComponentAt (Point< int > position)
| Returns the component at a certain point within this one. More...
void | repaint ()
| Marks the whole component as needing to be redrawn. More...
void | repaint (int x, int y, int width, int height)
| Marks a subsection of this component as needing to be redrawn. More...
void | repaint (Rectangle< int > area)
| Marks a subsection of this component as needing to be redrawn. More...
void | setBufferedToImage (bool shouldBeBuffered)
| Makes the component use an internal buffer to optimise its redrawing. More...
Image | createComponentSnapshot (Rectangle< int > areaToGrab, bool clipImageToComponentBounds=true, float scaleFactor=1.0f)
| Generates a snapshot of part of this component. More...
void | paintEntireComponent (Graphics &context, bool ignoreAlphaLevel)
| Draws this component and all its subcomponents onto the specified graphics context. More...
void | setPaintingIsUnclipped (bool shouldPaintWithoutClipping) noexcept
| This allows you to indicate that this component doesn't require its graphics context to be clipped when it is being painted. More...
bool | isPaintingUnclipped () const noexcept
| Returns true if this component doesn't require its graphics context to be clipped when it is being painted. More...
void | setComponentEffect (ImageEffectFilter *newEffect)
| Adds an effect filter to alter the component's appearance. More...
ImageEffectFilter * | getComponentEffect () const noexcept
| Returns the current component effect. More...
LookAndFeel & | getLookAndFeel () const noexcept
| Finds the appropriate look-and-feel to use for this component. More...
void | setLookAndFeel (LookAndFeel *newLookAndFeel)
| Sets the look and feel to use for this component. More...
virtual void | lookAndFeelChanged ()
| Called to let the component react to a change in the look-and-feel setting. More...
void | sendLookAndFeelChange ()
| Calls the lookAndFeelChanged() method in this component and all its children. More...
void | setOpaque (bool shouldBeOpaque)
| Indicates whether any parts of the component might be transparent. More...
bool | isOpaque () const noexcept
| Returns true if no parts of this component are transparent. More...
void | setBroughtToFrontOnMouseClick (bool shouldBeBroughtToFront) noexcept
| Indicates whether the component should be brought to the front when clicked. More...
bool | isBroughtToFrontOnMouseClick () const noexcept
| Indicates whether the component should be brought to the front when clicked-on. More...
void | setWantsKeyboardFocus (bool wantsFocus) noexcept
| Sets a flag to indicate whether this component needs keyboard focus or not. More...
bool | getWantsKeyboardFocus () const noexcept
| Returns true if the component is interested in getting keyboard focus. More...
void | setMouseClickGrabsKeyboardFocus (bool shouldGrabFocus)
| Chooses whether a click on this component automatically grabs the focus. More...
bool | getMouseClickGrabsKeyboardFocus () const noexcept
| Returns the last value set with setMouseClickGrabsKeyboardFocus(). More...
void | grabKeyboardFocus ()
| Tries to give keyboard focus to this component. More...
bool | hasKeyboardFocus (bool trueIfChildIsFocused) const
| Returns true if this component currently has the keyboard focus. More...
void | moveKeyboardFocusToSibling (bool moveToNext)
| Tries to move the keyboard focus to one of this component's siblings. More...
virtual KeyboardFocusTraverser * | createFocusTraverser ()
| Creates a KeyboardFocusTraverser object to use to determine the logic by which focus should be passed from this component. More...
int | getExplicitFocusOrder () const
| Returns the focus order of this component, if one has been specified. More...
void | setExplicitFocusOrder (int newFocusOrderIndex)
| Sets the index used in determining the order in which focusable components should be traversed. More...
void | setFocusContainer (bool shouldBeFocusContainer) noexcept
| Indicates whether this component is a parent for components that can have their focus traversed. More...
bool | isFocusContainer () const noexcept
| Returns true if this component has been marked as a focus container. More...
bool | isEnabled () const noexcept
| Returns true if the component (and all its parents) are enabled. More...
void | setEnabled (bool shouldBeEnabled)
| Enables or disables this component. More...
virtual void | enablementChanged ()
| Callback to indicate that this component has been enabled or disabled. More...
float | getAlpha () const noexcept
| Returns the component's current transparancy level. More...
void | setAlpha (float newAlpha)
| Changes the transparency of this component. More...
virtual void | alphaChanged ()
| Called when setAlpha() is used to change the alpha value of this component. More...
void | setMouseCursor (const MouseCursor &cursorType)
| Changes the mouse cursor shape to use when the mouse is over this component. More...
virtual MouseCursor | getMouseCursor ()
| Returns the mouse cursor shape to use when the mouse is over this component. More...
void | updateMouseCursor () const
| Forces the current mouse cursor to be updated. More...
virtual void | paint (Graphics &g)
| Components can override this method to draw their content. More...
virtual void | paintOverChildren (Graphics &g)
| Components can override this method to draw over the top of their children. More...
void | mouseMove (const MouseEvent &event) override
| Called when the mouse moves inside a component. More...
void | mouseEnter (const MouseEvent &event) override
| Called when the mouse first enters a component. More...
void | mouseExit (const MouseEvent &event) override
| Called when the mouse moves out of a component. More...
void | mouseDown (const MouseEvent &event) override
| Called when a mouse button is pressed. More...
void | mouseDrag (const MouseEvent &event) override
| Called when the mouse is moved while a button is held down. More...
void | mouseUp (const MouseEvent &event) override
| Called when a mouse button is released. More...
void | mouseDoubleClick (const MouseEvent &event) override
| Called when a mouse button has been double-clicked on a component. More...
void | mouseWheelMove (const MouseEvent &event, const MouseWheelDetails &wheel) override
| Called when the mouse-wheel is moved. More...
void | mouseMagnify (const MouseEvent &event, float scaleFactor) override
| Called when a pinch-to-zoom mouse-gesture is used. More...
void | setRepaintsOnMouseActivity (bool shouldRepaint) noexcept
| Causes automatic repaints when the mouse enters or exits this component. More...
void | addMouseListener (MouseListener *newListener, bool wantsEventsForAllNestedChildComponents)
| Registers a listener to be told when mouse events occur in this component. More...
void | removeMouseListener (MouseListener *listenerToRemove)
| Deregisters a mouse listener. More...
void | addKeyListener (KeyListener *newListener)
| Adds a listener that wants to hear about keypresses that this component receives. More...
void | removeKeyListener (KeyListener *listenerToRemove)
| Removes a previously-registered key listener. More...
virtual bool | keyPressed (const KeyPress &key)
| Called when a key is pressed. More...
virtual bool | keyStateChanged (bool isKeyDown)
| Called when a key is pressed or released. More...
virtual void | modifierKeysChanged (const ModifierKeys &modifiers)
| Called when a modifier key is pressed or released. More...
virtual void | focusGained (FocusChangeType cause)
| Called to indicate that this component has just acquired the keyboard focus. More...
virtual void | focusLost (FocusChangeType cause)
| Called to indicate that this component has just lost the keyboard focus. More...
virtual void | focusOfChildComponentChanged (FocusChangeType cause)
| Called to indicate a change in whether or not this component is the parent of the currently-focused component. More...
bool | isMouseOver (bool includeChildren=false) const
| Returns true if the mouse is currently over this component. More...
bool | isMouseButtonDown (bool includeChildren=false) const
| Returns true if the mouse button is currently held down in this component. More...
bool | isMouseOverOrDragging (bool includeChildren=false) const
| True if the mouse is over this component, or if it's being dragged in this component. More...
Point< int > | getMouseXYRelative () const
| Returns the mouse's current position, relative to this component. More...
virtual void | resized ()
| Called when this component's size has been changed. More...
virtual void | moved ()
| Called when this component's position has been changed. More...
virtual void | childBoundsChanged (Component *child)
| Called when one of this component's children is moved or resized. More...
virtual void | parentSizeChanged ()
| Called when this component's immediate parent has been resized. More...
virtual void | broughtToFront ()
| Called when this component has been moved to the front of its siblings. More...
void | addComponentListener (ComponentListener *newListener)
| Adds a listener to be told about changes to the component hierarchy or position. More...
void | removeComponentListener (ComponentListener *listenerToRemove)
| Removes a component listener. More...
void | postCommandMessage (int commandId)
| Dispatches a numbered message to this component. More...
virtual void | handleCommandMessage (int commandId)
| Called to handle a command that was sent by postCommandMessage(). More...
int | runModalLoop ()
| Runs a component modally, waiting until the loop terminates. More...
void | enterModalState (bool takeKeyboardFocus=true, ModalComponentManager::Callback *callback=nullptr, bool deleteWhenDismissed=false)
| Puts the component into a modal state. More...
void | exitModalState (int returnValue)
| Ends a component's modal state. More...
bool | isCurrentlyModal (bool onlyConsiderForemostModalComponent=true) const noexcept
| Returns true if this component is the modal one. More...
bool | isCurrentlyBlockedByAnotherModalComponent () const
| Checks whether there's a modal component somewhere that's stopping this one from receiving messages. More...
virtual bool | canModalEventBeSentToComponent (const Component *targetComponent)
| When a component is modal, this callback allows it to choose which other components can still receive events. More...
virtual void | inputAttemptWhenModal ()
| Called when the user tries to click on a component that is blocked by another modal component. More...
NamedValueSet & | getProperties () noexcept
| Returns the set of properties that belong to this component. More...
const NamedValueSet & | getProperties () const noexcept
| Returns the set of properties that belong to this component. More...
Colour | findColour (int colourID, bool inheritFromParent=false) const
| Looks for a colour that has been registered with the given colour ID number. More...
void | setColour (int colourID, Colour newColour)
| Registers a colour to be used for a particular purpose. More...
void | removeColour (int colourID)
| If a colour has been set with setColour(), this will remove it. More...
bool | isColourSpecified (int colourID) const
| Returns true if the specified colour ID has been explicitly set for this component using the setColour() method. More...
void | copyAllExplicitColoursTo (Component &target) const
| This looks for any colours that have been specified for this component, and copies them to the specified target component. More...
virtual void | colourChanged ()
| This method is called when a colour is changed by the setColour() method. More...
void * | getWindowHandle () const
| Returns the underlying native window handle for this component. More...
Positioner * | getPositioner () const noexcept
| Returns the Positioner object that has been set for this component. More...
void | setPositioner (Positioner *newPositioner)
| Sets a new Positioner object for this component. More...
void | setCachedComponentImage (CachedComponentImage *newCachedImage)
| Gives the component a CachedComponentImage that should be used to buffer its painting. More...
CachedComponentImage * | getCachedComponentImage () const noexcept
| Returns the object that was set by setCachedComponentImage(). More...
void | setViewportIgnoreDragFlag (bool ignoreDrag) noexcept
| Sets a flag to indicate whether mouse drag events on this Component should be ignored when it is inside a Viewport with drag-to-scroll functionality enabled. More...
bool | getViewportIgnoreDragFlag () const noexcept
| Retrieves the current state of the Viewport drag-to-scroll functionality flag. More...
Public Member Functions inherited from MouseListener
virtual | ~MouseListener ()=default
| Destructor. More...

## Static Public Member Functions
static float JUCE_CALLTYPE | getApproximateScaleFactorForComponent (Component *targetComponent)
| Returns the approximate scale factor for a given component by traversing its parent hierarchy and applying each transform and finally scaling this by the global scale factor. More...
static Component *JUCE_CALLTYPE | getCurrentlyFocusedComponent () noexcept
| Returns the component that currently has the keyboard focus. More...
static void JUCE_CALLTYPE | unfocusAllComponents ()
| If any component has keyboard focus, this will defocus it. More...
static void JUCE_CALLTYPE | beginDragAutoRepeat (int millisecondsBetweenCallbacks)
| Ensures that a non-stop stream of mouse-drag events will be sent during the current mouse-drag operation. More...
static bool JUCE_CALLTYPE | isMouseButtonDownAnywhere () noexcept
| Returns true if a mouse button is currently down. More...
static int JUCE_CALLTYPE | getNumCurrentlyModalComponents () noexcept
| Returns the number of components that are currently in a modal state. More...
static Component *JUCE_CALLTYPE | getCurrentlyModalComponent (int index=0) noexcept
| Returns one of the components that are currently modal. More...

## Detailed Description

The base class for all JUCE user-interface objects.

## Member Enumeration Documentation

## ◆ FocusChangeType

enum Component::FocusChangeType

Enumeration used by the focusGained() and focusLost() methods.

Enumerator
focusChangedByMouseClick | Means that the user clicked the mouse to change focus.
focusChangedByTabKey | Means that the user pressed the tab key to move the focus.
focusChangedDirectly | Means that the focus was changed by a call to grabKeyboardFocus().

## Constructor & Destructor Documentation

## ◆ Component() [1/2]

Component::Component | ( |  | ) |
| noexcept

Creates a component.

To get it to actually appear, you'll also need to:

- Either add it to a parent component or use the addToDesktop() method to make it a desktop window
- Set its size and position to something sensible
- Use setVisible() to make it visible

And for it to serve any useful purpose, you'll need to write a subclass of Component or use one of the other types of component from the library.

## ◆ ~Component()

Component::~Component | ( |  | ) |
| override

Destructor.

Note that when a component is deleted, any child components it contains are NOT automatically deleted. It's your responsibilty to manage their lifespan - you may want to use helper methods like deleteAllChildren(), or less haphazard approaches like using std::unique_ptrs or normal object aggregation to manage them.

If the component being deleted is currently the child of another one, then during deletion, it will be removed from its parent, and the parent will receive a childrenChanged() callback. Any ComponentListener objects that have registered with it will also have their ComponentListener::componentBeingDeleted() methods called.

## ◆ Component() [2/2]

Component::Component | ( | const String & | componentName | ) |
| explicitnoexcept

Creates a component, setting its name at the same time.

See also
  getName, setName

## Member Function Documentation

## ◆ getName()

const String& Component::getName | ( |  | ) | const
| noexcept

Returns the name of this component.

See also
  setName

## ◆ setName()

virtual void Component::setName | ( | const String & | newName | ) |
| virtual

Sets the name of this component.

When the name changes, all registered ComponentListeners will receive a ComponentListener::componentNameChanged() callback.

See also
  getName

Reimplemented in DocumentWindow.

## ◆ getComponentID()

const String& Component::getComponentID | ( |  | ) | const
| noexcept

Returns the ID string that was set by setComponentID().

See also
  setComponentID, findChildWithID

## ◆ setComponentID()

void Component::setComponentID | ( | const String & | newID | ) |

Sets the component's ID string.

You can retrieve the ID using getComponentID().

See also
  getComponentID, findChildWithID

## ◆ setVisible()

virtual void Component::setVisible | ( | bool | shouldBeVisible | ) |
| virtual

Makes the component visible or invisible.

This method will show or hide the component. Note that components default to being non-visible when first created. Also note that visible components won't be seen unless all their parent components are also visible.

This method will call visibilityChanged() and also componentVisibilityChanged() for any component listeners that are interested in this component.

Parameters

  shouldBeVisible | whether to show or hide the component

See also
  isVisible, isShowing, visibilityChanged, ComponentListener::componentVisibilityChanged

Reimplemented in ScrollBar.

Referenced by LassoComponent< SelectableItemType >::dragLasso(), and LassoComponent< SelectableItemType >::endLasso().

## ◆ isVisible()

bool Component::isVisible | ( |  | ) | const
| noexcept

Tests whether the component is visible or not.

this doesn't necessarily tell you whether this comp is actually on the screen because this depends on whether all the parent components are also visible - use isShowing() to find this out.

See also
  isShowing, setVisible

## ◆ visibilityChanged()

virtual void Component::visibilityChanged | ( |  | ) |
| virtual

Called when this component's visibility changes.

See also
  setVisible, isVisible

Reimplemented in ListBox, Button, ResizableWindow, TopLevelWindow, WebBrowserComponent, and ProgressBar.

## ◆ isShowing()

bool Component::isShowing | ( |  | ) | const

Tests whether this component and all its parents are visible.

Returns
  true only if this component and all its parents are visible.

See also
  isVisible

## ◆ addToDesktop()

virtual void Component::addToDesktop | ( | int | windowStyleFlags,
|  | void * | nativeWindowToAttachTo = `nullptr`
| ) |  |
| virtual

Makes this component appear as a window on the desktop.

Note that before calling this, you should make sure that the component's opacity is set correctly using setOpaque(). If the component is non-opaque, the windowing system will try to create a special transparent window for it, which will generally take a lot more CPU to operate (and might not even be possible on some platforms).

If the component is inside a parent component at the time this method is called, it will first be removed from that parent. Likewise if a component is on the desktop and is subsequently added to another component, it'll be removed from the desktop.

Parameters

  windowStyleFlags | a combination of the flags specified in the ComponentPeer::StyleFlags enum, which define the window's characteristics.
  nativeWindowToAttachTo | this allows an OS object to be passed-in as the window in which the juce component should place itself. On Windows, this would be a HWND, a HIViewRef on the Mac. Not necessarily supported on all platforms, and best left as 0 unless you know what you're doing.

See also
  removeFromDesktop, isOnDesktop, userTriedToCloseWindow, getPeer, ComponentPeer::setMinimised, ComponentPeer::StyleFlags, ComponentPeer::getStyleFlags, ComponentPeer::setFullScreen

Reimplemented in TopLevelWindow.

## ◆ removeFromDesktop()

void Component::removeFromDesktop | ( |  | ) |

If the component is currently showing on the desktop, this will hide it.

You can also use setVisible() to hide a desktop window temporarily, but removeFromDesktop() will free any system resources that are being used up.

See also
  addToDesktop, isOnDesktop

## ◆ isOnDesktop()

bool Component::isOnDesktop | ( |  | ) | const
| noexcept

Returns true if this component is currently showing on the desktop.

See also
  addToDesktop, removeFromDesktop

## ◆ getPeer()

ComponentPeer* Component::getPeer | ( |  | ) | const

Returns the heavyweight window that contains this component.

If this component is itself on the desktop, this will return the window object that it is using. Otherwise, it will return the window of its top-level parent component.

This may return nullptr if there isn't a desktop component.

See also
  addToDesktop, isOnDesktop

## ◆ userTriedToCloseWindow()

virtual void Component::userTriedToCloseWindow | ( |  | ) |
| virtual

For components on the desktop, this is called if the system wants to close the window.

This is a signal that either the user or the system wants the window to close. The default implementation of this method will trigger an assertion to warn you that your component should do something about it, but you can override this to ignore the event if you want.

Reimplemented in AlertWindow.

## ◆ minimisationStateChanged()

virtual void Component::minimisationStateChanged | ( | bool | isNowMinimised | ) |
| virtual

Called for a desktop component which has just been minimised or un-minimised.

This will only be called for components on the desktop.

See also
  getPeer, ComponentPeer::setMinimised, ComponentPeer::isMinimised

## ◆ getDesktopScaleFactor()

virtual float Component::getDesktopScaleFactor | ( |  | ) | const
| virtual

Returns the default scale factor to use for this component when it is placed on the desktop.

The default implementation of this method just returns the value from Desktop::getGlobalScaleFactor(), but it can be overridden if a particular component has different requirements. The method only used if this component is added to the desktop - it has no effect for child components.

## ◆ toFront()

void Component::toFront | ( | bool | shouldAlsoGainFocus | ) |

Brings the component to the front of its siblings.

If some of the component's siblings have had their 'always-on-top' flag set, then they will still be kept in front of this one (unless of course this one is also 'always-on-top').

Parameters

  shouldAlsoGainFocus | if true, this will also try to assign keyboard focus to the component (see grabKeyboardFocus() for more details)

See also
  toBack, toBehind, setAlwaysOnTop

## ◆ toBack()

void Component::toBack | ( |  | ) |

Changes this component's z-order to be at the back of all its siblings.

If the component is set to be 'always-on-top', it will only be moved to the back of the other other 'always-on-top' components.

See also
  toFront, toBehind, setAlwaysOnTop

## ◆ toBehind()

void Component::toBehind | ( | Component * | other | ) |

Changes this component's z-order so that it's just behind another component.

See also
  toFront, toBack

## ◆ setAlwaysOnTop()

void Component::setAlwaysOnTop | ( | bool | shouldStayOnTop | ) |

Sets whether the component should always be kept at the front of its siblings.

See also
  isAlwaysOnTop

## ◆ isAlwaysOnTop()

bool Component::isAlwaysOnTop | ( |  | ) | const
| noexcept

Returns true if this component is set to always stay in front of its siblings.

See also
  setAlwaysOnTop

## ◆ getX()

int Component::getX | ( |  | ) | const
| noexcept

Returns the x coordinate of the component's left edge.

This is a distance in pixels from the left edge of the component's parent.

Note that if you've used setTransform() to apply a transform, then the component's bounds will no longer be a direct reflection of the position at which it appears within its parent, as the transform will be applied to its bounding box.

Referenced by StandaloneFilterWindow::~StandaloneFilterWindow().

## ◆ getY()

int Component::getY | ( |  | ) | const
| noexcept

Returns the y coordinate of the top of this component.

This is a distance in pixels from the top edge of the component's parent.

Note that if you've used setTransform() to apply a transform, then the component's bounds will no longer be a direct reflection of the position at which it appears within its parent, as the transform will be applied to its bounding box.

Referenced by StandaloneFilterWindow::~StandaloneFilterWindow().

## ◆ getWidth()

int Component::getWidth | ( |  | ) | const
| noexcept

Returns the component's width in pixels.

Referenced by TabbedButtonBar::getThickness().

## ◆ getHeight()

int Component::getHeight | ( |  | ) | const
| noexcept

Returns the component's height in pixels.

Referenced by TabbedButtonBar::getThickness().

## ◆ getRight()

int Component::getRight | ( |  | ) | const
| noexcept

Returns the x coordinate of the component's right-hand edge.

This is a distance in pixels from the left edge of the component's parent.

Note that if you've used setTransform() to apply a transform, then the component's bounds will no longer be a direct reflection of the position at which it appears within its parent, as the transform will be applied to its bounding box.

## ◆ getPosition()

Point<int> Component::getPosition | ( |  | ) | const
| noexcept

Returns the component's top-left position as a Point.

## ◆ getBottom()

int Component::getBottom | ( |  | ) | const
| noexcept

Returns the y coordinate of the bottom edge of this component.

This is a distance in pixels from the top edge of the component's parent.

Note that if you've used setTransform() to apply a transform, then the component's bounds will no longer be a direct reflection of the position at which it appears within its parent, as the transform will be applied to its bounding box.

## ◆ getBounds()

Rectangle<int> Component::getBounds | ( |  | ) | const
| noexcept

Returns this component's bounding box.

The rectangle returned is relative to the top-left of the component's parent.

Note that if you've used setTransform() to apply a transform, then the component's bounds will no longer be a direct reflection of the position at which it appears within its parent, as the transform will be applied to its bounding box.

Referenced by LassoComponent< SelectableItemType >::dragLasso().

## ◆ getLocalBounds()

Rectangle<int> Component::getLocalBounds | ( |  | ) | const
| noexcept

Returns the component's bounds, relative to its own origin.

This is like getBounds(), but returns the rectangle in local coordinates, In practice, it'll return a rectangle with position (0, 0), and the same size as this component.

## ◆ getBoundsInParent()

Rectangle<int> Component::getBoundsInParent | ( |  | ) | const
| noexcept

Returns the area of this component's parent which this component covers.

The returned area is relative to the parent's coordinate space. If the component has an affine transform specified, then the resulting area will be the smallest rectangle that fully covers the component's transformed bounding box. If this component has no parent, the return value will simply be the same as getBounds().

## ◆ getScreenX()

int Component::getScreenX | ( |  | ) | const

Returns this component's x coordinate relative the screen's top-left origin.

See also
  getX, localPointToGlobal

## ◆ getScreenY()

int Component::getScreenY | ( |  | ) | const

Returns this component's y coordinate relative the screen's top-left origin.

See also
  getY, localPointToGlobal

## ◆ getScreenPosition()

Point<int> Component::getScreenPosition | ( |  | ) | const

Returns the position of this component's top-left corner relative to the screen's top-left.

See also
  getScreenBounds

## ◆ getScreenBounds()

Rectangle<int> Component::getScreenBounds | ( |  | ) | const

Returns the bounds of this component, relative to the screen's top-left.

See also
  getScreenPosition

## ◆ getLocalPoint() [1/2]

Point<int> Component::getLocalPoint | ( | const Component * | sourceComponent,
|  | Point< int > | pointRelativeToSourceComponent
| ) |  | const

Converts a point to be relative to this component's coordinate space.

This takes a point relative to a different component, and returns its position relative to this component. If the sourceComponent parameter is null, the source point is assumed to be a global screen coordinate.

## ◆ getLocalPoint() [2/2]

Point<float> Component::getLocalPoint | ( | const Component * | sourceComponent,
|  | Point< float > | pointRelativeToSourceComponent
| ) |  | const

Converts a point to be relative to this component's coordinate space.

This takes a point relative to a different component, and returns its position relative to this component. If the sourceComponent parameter is null, the source point is assumed to be a global screen coordinate.

## ◆ getLocalArea()

Rectangle<int> Component::getLocalArea | ( | const Component * | sourceComponent,
|  | Rectangle< int > | areaRelativeToSourceComponent
| ) |  | const

Converts a rectangle to be relative to this component's coordinate space.

This takes a rectangle that is relative to a different component, and returns its position relative to this component. If the sourceComponent parameter is null, the source rectangle is assumed to be a screen coordinate.

If you've used setTransform() to apply one or more transforms to components, then the source rectangle may not actually be rectanglular when converted to the target space, so in that situation this will return the smallest rectangle that fully contains the transformed area.

## ◆ localPointToGlobal() [1/2]

Point<int> Component::localPointToGlobal | ( | Point< int > | localPoint | ) | const

Converts a point relative to this component's top-left into a screen coordinate.

See also
  getLocalPoint, localAreaToGlobal

## ◆ localPointToGlobal() [2/2]

Point<float> Component::localPointToGlobal | ( | Point< float > | localPoint | ) | const

Converts a point relative to this component's top-left into a screen coordinate.

See also
  getLocalPoint, localAreaToGlobal

## ◆ localAreaToGlobal()

Rectangle<int> Component::localAreaToGlobal | ( | Rectangle< int > | localArea | ) | const

Converts a rectangle from this component's coordinate space to a screen coordinate.

If you've used setTransform() to apply one or more transforms to components, then the source rectangle may not actually be rectanglular when converted to the target space, so in that situation this will return the smallest rectangle that fully contains the transformed area.

See also
  getLocalPoint, localPointToGlobal

## ◆ setTopLeftPosition() [1/2]

void Component::setTopLeftPosition | ( | int | x,
|  | int | y
| ) |  |

Moves the component to a new position.

Changes the component's top-left position (without changing its size). The position is relative to the top-left of the component's parent.

If the component actually moves, this method will make a synchronous call to moved().

Note that if you've used setTransform() to apply a transform, then the component's bounds will no longer be a direct reflection of the position at which it appears within its parent, as the transform will be applied to whatever bounds you set for it.

See also
  setBounds, ComponentListener::componentMovedOrResized

## ◆ setTopLeftPosition() [2/2]

void Component::setTopLeftPosition | ( | Point< int > | newTopLeftPosition | ) |

Moves the component to a new position.

Changes the component's top-left position (without changing its size). The position is relative to the top-left of the component's parent.

If the component actually moves, this method will make a synchronous call to moved().

Note that if you've used setTransform() to apply a transform, then the component's bounds will no longer be a direct reflection of the position at which it appears within its parent, as the transform will be applied to whatever bounds you set for it.

See also
  setBounds, ComponentListener::componentMovedOrResized

## ◆ setTopRightPosition()

void Component::setTopRightPosition | ( | int | x,
|  | int | y
| ) |  |

Moves the component to a new position.

Changes the position of the component's top-right corner (keeping it the same size). The position is relative to the top-left of the component's parent.

If the component actually moves, this method will make a synchronous call to moved().

Note that if you've used setTransform() to apply a transform, then the component's bounds will no longer be a direct reflection of the position at which it appears within its parent, as the transform will be applied to whatever bounds you set for it.

## ◆ setSize()

void Component::setSize | ( | int | newWidth,
|  | int | newHeight
| ) |  |

Changes the size of the component.

A synchronous call to resized() will occur if the size actually changes.

Note that if you've used setTransform() to apply a transform, then the component's bounds will no longer be a direct reflection of the position at which it appears within its parent, as the transform will be applied to whatever bounds you set for it.

Referenced by LassoComponent< SelectableItemType >::beginLasso(), and StandalonePluginHolder::showAudioSettingsDialog().

## ◆ setBounds() [1/2]

void Component::setBounds | ( | int | x,
|  | int | y,
|  | int | width,
|  | int | height
| ) |  |

Changes the component's position and size.

The coordinates are relative to the top-left of the component's parent, or relative to the origin of the screen if the component is on the desktop.

If this method changes the component's top-left position, it will make a synchronous call to moved(). If it changes the size, it will also make a call to resized().

Note that if you've used setTransform() to apply a transform, then the component's bounds will no longer be a direct reflection of the position at which it appears within its parent, as the transform will be applied to whatever bounds you set for it.

See also
  setTopLeftPosition, setSize, ComponentListener::componentMovedOrResized

Referenced by LassoComponent< SelectableItemType >::dragLasso(), and StandaloneFilterWindow::resized().

## ◆ setBounds() [2/2]

void Component::setBounds | ( | Rectangle< int > | newBounds | ) |

Changes the component's position and size.

The coordinates are relative to the top-left of the component's parent, or relative to the origin of the screen if the component is on the desktop.

If this method changes the component's top-left position, it will make a synchronous call to moved(). If it changes the size, it will also make a call to resized().

Note that if you've used setTransform() to apply a transform, then the component's bounds will no longer be a direct reflection of the position at which it appears within its parent, as the transform will be applied to whatever bounds you set for it.

See also
  setBounds

## ◆ setBoundsRelative() [1/2]

void Component::setBoundsRelative | ( | float | proportionalX,
|  | float | proportionalY,
|  | float | proportionalWidth,
|  | float | proportionalHeight
| ) |  |

Changes the component's position and size in terms of fractions of its parent's size.

The values are factors of the parent's size, so for example setBoundsRelative (0.2f, 0.2f, 0.5f, 0.5f) would give it half the width and height of the parent, with its top-left position 20% of the way across and down the parent.

See also
  setBounds

## ◆ setBoundsRelative() [2/2]

void Component::setBoundsRelative | ( | Rectangle< float > | proportionalArea | ) |

Changes the component's position and size in terms of fractions of its parent's size.

The values are factors of the parent's size, so for example setBoundsRelative ({ 0.2f, 0.2f, 0.5f, 0.5f }) would give it half the width and height of the parent, with its top-left position 20% of the way across and down the parent.

See also
  setBounds

## ◆ setBoundsInset()

void Component::setBoundsInset | ( | BorderSize< int > | borders | ) |

Changes the component's position and size based on the amount of space to leave around it.

This will position the component within its parent, leaving the specified number of pixels around each edge.

See also
  setBounds

## ◆ setBoundsToFit()

void Component::setBoundsToFit | ( | Rectangle< int > | targetArea,
|  | Justification | justification,
|  | bool | onlyReduceInSize
| ) |  |

Positions the component within a given rectangle, keeping its proportions unchanged.

If onlyReduceInSize is false, the component will be resized to fill as much of the rectangle as possible without changing its aspect ratio (the component's current size is used to determine its aspect ratio, so a zero-size component won't work here). If onlyReduceInSize is true, it will only be resized if it's too big to fit inside the rectangle.

It will then be positioned within the rectangle according to the justification flags specified.

See also
  setBounds

## ◆ setCentrePosition() [1/2]

void Component::setCentrePosition | ( | int | x,
|  | int | y
| ) |  |

Changes the position of the component's centre.

Leaves the component's size unchanged, but sets the position of its centre relative to its parent's top-left.

See also
  setBounds

## ◆ setCentrePosition() [2/2]

void Component::setCentrePosition | ( | Point< int > | newCentrePosition | ) |

Changes the position of the component's centre.

Leaves the component's size unchanged, but sets the position of its centre relative to its parent's top-left.

See also
  setBounds

## ◆ setCentreRelative()

void Component::setCentreRelative | ( | float | x,
|  | float | y
| ) |  |

Changes the position of the component's centre.

Leaves the size unchanged, but positions its centre relative to its parent's size. E.g. setCentreRelative (0.5f, 0.5f) would place it centrally in its parent.

## ◆ centreWithSize()

void Component::centreWithSize | ( | int | width,
|  | int | height
| ) |  |

Changes the component's size and centres it within its parent.

After changing the size, the component will be moved so that it's centred within its parent. If the component is on the desktop (or has no parent component), then it'll be centred within the main monitor area.

## ◆ setTransform()

void Component::setTransform | ( | const AffineTransform & | transform | ) |

Sets a transform matrix to be applied to this component.

If you set a transform for a component, the component's position will be warped by it, relative to the component's parent's top-left origin. This means that the values you pass into setBounds() will no longer reflect the actual area within the parent that the component covers, as the bounds will be transformed and the component will probably end up actually appearing somewhere else within its parent.

When using transforms you need to be extremely careful when converting coordinates between the coordinate spaces of different components or the screen - you should always use getLocalPoint(), getLocalArea(), etc to do this, and never just manually add a component's position to a point in order to convert it between different components (but I'm sure you would never have done that anyway...).

Currently, transforms are not supported for desktop windows, so the transform will be ignored if you put a component on the desktop.

To remove a component's transform, simply pass AffineTransform() as the parameter to this method.

## ◆ getTransform()

AffineTransform Component::getTransform | ( |  | ) | const

Returns the transform that is currently being applied to this component.

For more details about transforms, see setTransform().

See also
  setTransform

## ◆ isTransformed()

bool Component::isTransformed | ( |  | ) | const
| noexcept

Returns true if a non-identity transform is being applied to this component.

For more details about transforms, see setTransform().

See also
  setTransform

## ◆ getApproximateScaleFactorForComponent()

static float JUCE_CALLTYPE Component::getApproximateScaleFactorForComponent | ( | Component * | targetComponent | ) |
| static

Returns the approximate scale factor for a given component by traversing its parent hierarchy and applying each transform and finally scaling this by the global scale factor.

## ◆ proportionOfWidth()

int Component::proportionOfWidth | ( | float | proportion | ) | const
| noexcept

Returns a proportion of the component's width.

This is a handy equivalent of (getWidth() * proportion).

## ◆ proportionOfHeight()

int Component::proportionOfHeight | ( | float | proportion | ) | const
| noexcept

Returns a proportion of the component's height.

This is a handy equivalent of (getHeight() * proportion).

## ◆ getParentWidth()

int Component::getParentWidth | ( |  | ) | const
| noexcept

Returns the width of the component's parent.

If the component has no parent (i.e. if it's on the desktop), this will return the width of the screen.

## ◆ getParentHeight()

int Component::getParentHeight | ( |  | ) | const
| noexcept

Returns the height of the component's parent.

If the component has no parent (i.e. if it's on the desktop), this will return the height of the screen.

## ◆ getParentMonitorArea()

Rectangle<int> Component::getParentMonitorArea | ( |  | ) | const

Returns the screen coordinates of the monitor that contains this component.

If there's only one monitor, this will return its size - if there are multiple monitors, it will return the area of the monitor that contains the component's centre.

## ◆ getNumChildComponents()

int Component::getNumChildComponents | ( |  | ) | const
| noexcept

Returns the number of child components that this component contains.

See also
  getChildren, getChildComponent, getIndexOfChildComponent

## ◆ getChildComponent()

Component* Component::getChildComponent | ( | int | index | ) | const
| noexcept

Returns one of this component's child components, by it index.

The component with index 0 is at the back of the z-order, the one at the front will have index (getNumChildComponents() - 1).

If the index is out-of-range, this will return a null pointer.

See also
  getChildren, getNumChildComponents, getIndexOfChildComponent

## ◆ getIndexOfChildComponent()

int Component::getIndexOfChildComponent | ( | const Component * | child | ) | const
| noexcept

Returns the index of this component in the list of child components.

A value of 0 means it is first in the list (i.e. behind all other components). Higher values are further towards the front.

Returns -1 if the component passed-in is not a child of this component.

See also
  getChildren, getNumChildComponents, getChildComponent, addChildComponent, toFront, toBack, toBehind

## ◆ getChildren()

const Array<Component*>& Component::getChildren | ( |  | ) | const
| noexcept

Provides access to the underlying array of child components.

The most likely reason you may want to use this is for iteration in a range-based for loop.

## ◆ findChildWithID()

Component* Component::findChildWithID | ( | StringRef | componentID | ) | const
| noexcept

Looks for a child component with the specified ID.

See also
  setComponentID, getComponentID

## ◆ addChildComponent() [1/2]

void Component::addChildComponent | ( | Component * | child,
|  | int | zOrder = `-1`
| ) |  |

Adds a child component to this one.

Adding a child component does not mean that the component will own or delete the child - it's your responsibility to delete the component. Note that it's safe to delete a component without first removing it from its parent - doing so will automatically remove it and send out the appropriate notifications before the deletion completes.

If the child is already a child of this component, then no action will be taken, and its z-order will be left unchanged.

Parameters

  child | the new component to add. If the component passed-in is already the child of another component, it'll first be removed from it current parent.
  zOrder | The index in the child-list at which this component should be inserted. A value of -1 will insert it in front of the others, 0 is the back.

See also
  removeChildComponent, addAndMakeVisible, addChildAndSetID, getChild, ComponentListener::componentChildrenChanged

## ◆ addChildComponent() [2/2]

void Component::addChildComponent | ( | Component & | child,
|  | int | zOrder = `-1`
| ) |  |

Adds a child component to this one.

Adding a child component does not mean that the component will own or delete the child - it's your responsibility to delete the component. Note that it's safe to delete a component without first removing it from its parent - doing so will automatically remove it and send out the appropriate notifications before the deletion completes.

If the child is already a child of this component, then no action will be taken, and its z-order will be left unchanged.

Parameters

  child | the new component to add. If the component passed-in is already the child of another component, it'll first be removed from it current parent.
  zOrder | The index in the child-list at which this component should be inserted. A value of -1 will insert it in front of the others, 0 is the back.

See also
  removeChildComponent, addAndMakeVisible, addChildAndSetID, getChild, ComponentListener::componentChildrenChanged

## ◆ addAndMakeVisible() [1/2]

void Component::addAndMakeVisible | ( | Component * | child,
|  | int | zOrder = `-1`
| ) |  |

Adds a child component to this one, and also makes the child visible if it isn't already.

This is the same as calling setVisible (true) on the child and then addChildComponent(). See addChildComponent() for more details.

Parameters

  child | the new component to add. If the component passed-in is already the child of another component, it'll first be removed from it current parent.
  zOrder | The index in the child-list at which this component should be inserted. A value of -1 will insert it in front of the others, 0 is the back.

## ◆ addAndMakeVisible() [2/2]

void Component::addAndMakeVisible | ( | Component & | child,
|  | int | zOrder = `-1`
| ) |  |

Adds a child component to this one, and also makes the child visible if it isn't already.

This is the same as calling setVisible (true) on the child and then addChildComponent(). See addChildComponent() for more details.

Parameters

  child | the new component to add. If the component passed-in is already the child of another component, it'll first be removed from it current parent.
  zOrder | The index in the child-list at which this component should be inserted. A value of -1 will insert it in front of the others, 0 is the back.

## ◆ addChildAndSetID()

void Component::addChildAndSetID | ( | Component * | child,
|  | const String & | componentID
| ) |  |

Adds a child component to this one, makes it visible, and sets its component ID.

See also
  addAndMakeVisible, addChildComponent

## ◆ removeChildComponent() [1/2]

void Component::removeChildComponent | ( | Component * | childToRemove | ) |

Removes one of this component's child-components.

If the child passed-in isn't actually a child of this component (either because it's invalid or is the child of a different parent), then no action is taken.

Note that removing a child will not delete it! But it's ok to delete a component without first removing it - doing so will automatically remove it and send out the appropriate notifications before the deletion completes.

See also
  addChildComponent, ComponentListener::componentChildrenChanged

## ◆ removeChildComponent() [2/2]

Component* Component::removeChildComponent | ( | int | childIndexToRemove | ) |

Removes one of this component's child-components by index.

This will return a pointer to the component that was removed, or null if the index was out-of-range.

Note that removing a child will not delete it! But it's ok to delete a component without first removing it - doing so will automatically remove it and send out the appropriate notifications before the deletion completes.

See also
  addChildComponent, ComponentListener::componentChildrenChanged

## ◆ removeAllChildren()

void Component::removeAllChildren | ( |  | ) |

Removes all this component's children.

Note that this won't delete them! To do that, use deleteAllChildren() instead.

## ◆ deleteAllChildren()

void Component::deleteAllChildren | ( |  | ) |

Removes and deletes all of this component's children.

My advice is to avoid this method! It's an old function that is only kept here for backwards-compatibility with legacy code, and should be viewed with extreme suspicion by anyone attempting to write modern C++. In almost all cases, it's much smarter to manage the lifetimes of your child components via modern RAII techniques such as simply making them member variables, or using std::unique_ptr, OwnedArray, etc to manage their lifetimes appropriately.

See also
  removeAllChildren

## ◆ getParentComponent()

Component* Component::getParentComponent | ( |  | ) | const
| noexcept

Returns the component which this component is inside.

If this is the highest-level component or hasn't yet been added to a parent, this will return null.

Referenced by LassoComponent< SelectableItemType >::beginLasso().

## ◆ findParentComponentOfClass()

template<class TargetClass >

TargetClass* Component::findParentComponentOfClass | ( |  | ) | const

Searches the parent components for a component of a specified class.

For example findParentComponentOfClass <MyComp>() would return the first parent component that can be dynamically cast to a MyComp, or will return nullptr if none of the parents are suitable.

## ◆ getTopLevelComponent()

Component* Component::getTopLevelComponent | ( |  | ) | const
| noexcept

Returns the highest-level component which contains this one or its parents.

This will search upwards in the parent-hierarchy from this component, until it finds the highest one that doesn't have a parent (i.e. is on the desktop or not yet added to a parent), and will return that.

## ◆ isParentOf()

bool Component::isParentOf | ( | const Component * | possibleChild | ) | const
| noexcept

Checks whether a component is anywhere inside this component or its children.

This will recursively check through this component's children to see if the given component is anywhere inside.

## ◆ parentHierarchyChanged()

virtual void Component::parentHierarchyChanged | ( |  | ) |
| virtual

Called to indicate that the component's parents have changed.

When a component is added or removed from its parent, this method will be called on all of its children (recursively - so all children of its children will also be called as well).

Subclasses can override this if they need to react to this in some way.

See also
  getParentComponent, isShowing, ComponentListener::componentParentHierarchyChanged

Reimplemented in TextEditor, ListBox, Button, ComboBox, ScrollBar, Drawable, SidePanel, TopLevelWindow, WebBrowserComponent, KeyMappingEditorComponent, and DrawableComposite.

## ◆ childrenChanged()

virtual void Component::childrenChanged | ( |  | ) |
| virtual

Subclasses can use this callback to be told when children are added or removed, or when their z-order changes.

See also
  parentHierarchyChanged, ComponentListener::componentChildrenChanged

Reimplemented in DrawableComposite.

## ◆ hitTest()

virtual bool Component::hitTest | ( | int | x,
|  | int | y
| ) |  |
| virtual

Tests whether a given point is inside the component.

Overriding this method allows you to create components which only intercept mouse-clicks within a user-defined area.

This is called to find out whether a particular x, y coordinate is considered to be inside the component or not, and is used by methods such as contains() and getComponentAt() to work out which component the mouse is clicked on.

Components with custom shapes will probably want to override it to perform some more complex hit-testing.

The default implementation of this method returns either true or false, depending on the value that was set by calling setInterceptsMouseClicks() (true is the default return value).

Note that the hit-test region is not related to the opacity with which areas of a component are painted.

Applications should never call hitTest() directly - instead use the contains() method, because this will also test for occlusion by the component's parent.

Note that for components on the desktop, this method will be ignored, because it's not always possible to implement this behaviour on all platforms.

Parameters

  x | the x coordinate to test, relative to the left hand edge of this component. This value is guaranteed to be greater than or equal to zero, and less than the component's width
  y | the y coordinate to test, relative to the top edge of this component. This value is guaranteed to be greater than or equal to zero, and less than the component's height

Returns
  true if the click is considered to be inside the component

See also
  setInterceptsMouseClicks, contains

Reimplemented in LassoComponent< SelectableItemType >, ResizableBorderComponent, CallOutBox, ImageButton, TabBarButton, DrawableShape, DrawableImage, and ResizableCornerComponent.

## ◆ setInterceptsMouseClicks()

void Component::setInterceptsMouseClicks | ( | bool | allowClicksOnThisComponent,
|  | bool | allowClicksOnChildComponents
| ) |  |
| noexcept

Changes the default return value for the hitTest() method.

Setting this to false is an easy way to make a component pass all its mouse events (not just clicks) through to the components behind it.

When a component is created, the default setting for this is true.

Parameters

  allowClicksOnThisComponent | if true, hitTest() will always return true; if false, it will return false (or true for child components if allowClicksOnChildComponents is true)
  allowClicksOnChildComponents | if this is true and allowClicksOnThisComponent is false, then child components can be clicked on as normal but clicks on this component pass straight through; if this is false and allowClicksOnThisComponent is false, then neither this component nor any child components can be clicked on

See also
  hitTest, getInterceptsMouseClicks

## ◆ getInterceptsMouseClicks()

void Component::getInterceptsMouseClicks | ( | bool & | allowsClicksOnThisComponent,
|  | bool & | allowsClicksOnChildComponents
| ) |  | const
| noexcept

Retrieves the current state of the mouse-click interception flags.

On return, the two parameters are set to the state used in the last call to setInterceptsMouseClicks().

See also
  setInterceptsMouseClicks

## ◆ contains()

bool Component::contains | ( | Point< int > | localPoint | ) |

Returns true if a given point lies within this component or one of its children.

Never override this method! Use hitTest to create custom hit regions.

Parameters

  localPoint | the coordinate to test, relative to this component's top-left.

Returns
  true if the point is within the component's hit-test area, but only if that part of the component isn't clipped by its parent component. Note that this won't take into account any overlapping sibling components which might be in the way - for that, see reallyContains()

See also
  hitTest, reallyContains, getComponentAt

## ◆ reallyContains()

bool Component::reallyContains | ( | Point< int > | localPoint,
|  | bool | returnTrueIfWithinAChild
| ) |  |

Returns true if a given point lies in this component, taking any overlapping siblings into account.

Parameters

  localPoint | the coordinate to test, relative to this component's top-left.
  returnTrueIfWithinAChild | if the point actually lies within a child of this component, this determines whether that is counted as a hit.

See also
  contains, getComponentAt

## ◆ getComponentAt() [1/2]

Component* Component::getComponentAt | ( | int | x,
|  | int | y
| ) |  |

Returns the component at a certain point within this one.

Parameters

  x | the x coordinate to test, relative to this component's left edge.
  y | the y coordinate to test, relative to this component's top edge.

Returns
  the component that is at this position - which may be 0, this component, or one of its children. Note that overlapping siblings that might actually be in the way are not taken into account by this method - to account for these, instead call getComponentAt on the top-level parent of this component.

See also
  hitTest, contains, reallyContains

## ◆ getComponentAt() [2/2]

Component* Component::getComponentAt | ( | Point< int > | position | ) |

Returns the component at a certain point within this one.

Parameters

  position | the coordinate to test, relative to this component's top-left.

Returns
  the component that is at this position - which may be 0, this component, or one of its children. Note that overlapping siblings that might actually be in the way are not taken into account by this method - to account for these, instead call getComponentAt on the top-level parent of this component.

See also
  hitTest, contains, reallyContains

## ◆ repaint() [1/3]

void Component::repaint | ( |  | ) |

Marks the whole component as needing to be redrawn.

Calling this will not do any repainting immediately, but will mark the component as 'dirty'. At some point in the near future the operating system will send a paint message, which will redraw all the dirty regions of all components. There's no guarantee about how soon after calling repaint() the redraw will actually happen, and other queued events may be delivered before a redraw is done.

If the setBufferedToImage() method has been used to cause this component to use a buffer, the repaint() call will invalidate the cached buffer. If setCachedComponentImage() has been used to provide a custom image cache, that cache will be invalidated appropriately.

To redraw just a subsection of the component rather than the whole thing, use the repaint (int, int, int, int) method.

See also
  paint

## ◆ repaint() [2/3]

void Component::repaint | ( | int | x,
|  | int | y,
|  | int | width,
|  | int | height
| ) |  |

Marks a subsection of this component as needing to be redrawn.

Calling this will not do any repainting immediately, but will mark the given region of the component as 'dirty'. At some point in the near future the operating system will send a paint message, which will redraw all the dirty regions of all components. There's no guarantee about how soon after calling repaint() the redraw will actually happen, and other queued events may be delivered before a redraw is done.

The region that is passed in will be clipped to keep it within the bounds of this component.

See also
  repaint()

## ◆ repaint() [3/3]

void Component::repaint | ( | Rectangle< int > | area | ) |

Marks a subsection of this component as needing to be redrawn.

Calling this will not do any repainting immediately, but will mark the given region of the component as 'dirty'. At some point in the near future the operating system will send a paint message, which will redraw all the dirty regions of all components. There's no guarantee about how soon after calling repaint() the redraw will actually happen, and other queued events may be delivered before a redraw is done.

The region that is passed in will be clipped to keep it within the bounds of this component.

See also
  repaint()

## ◆ setBufferedToImage()

void Component::setBufferedToImage | ( | bool | shouldBeBuffered | ) |

Makes the component use an internal buffer to optimise its redrawing.

Setting this flag to true will cause the component to allocate an internal buffer into which it paints itself and all its child components, so that when asked to redraw itself, it can use this buffer rather than actually calling the paint() method.

Parts of the buffer are invalidated when repaint() is called on this component or its children. The buffer is then repainted at the next paint() callback.

See also
  repaint, paint, createComponentSnapshot

## ◆ createComponentSnapshot()

Image Component::createComponentSnapshot | ( | Rectangle< int > | areaToGrab,
|  | bool | clipImageToComponentBounds = `true`,
|  | float | scaleFactor = `1.0f`
| ) |  |

Generates a snapshot of part of this component.

This will return a new Image, the size of the rectangle specified, containing a snapshot of the specified area of the component and all its children.

The image may or may not have an alpha-channel, depending on whether the image is opaque or not.

If the clipImageToComponentBounds parameter is true and the area is greater than the size of the component, it'll be clipped. If clipImageToComponentBounds is false then parts of the component beyond its bounds can be drawn.

See also
  paintEntireComponent

## ◆ paintEntireComponent()

void Component::paintEntireComponent | ( | Graphics & | context,
|  | bool | ignoreAlphaLevel
| ) |  |

Draws this component and all its subcomponents onto the specified graphics context.

You should very rarely have to use this method, it's simply there in case you need to draw a component with a custom graphics context for some reason, e.g. for creating a snapshot of the component.

It calls paint(), paintOverChildren() and recursively calls paintEntireComponent() on its children in order to render the entire tree.

The graphics context may be left in an undefined state after this method returns, so you may need to reset it if you're going to use it again.

If ignoreAlphaLevel is false, then the component will be drawn with the opacity level specified by getAlpha(); if ignoreAlphaLevel is true, then this will be ignored and an alpha of 1.0 will be used.

## ◆ setPaintingIsUnclipped()

void Component::setPaintingIsUnclipped | ( | bool | shouldPaintWithoutClipping | ) |
| noexcept

This allows you to indicate that this component doesn't require its graphics context to be clipped when it is being painted.

Most people will never need to use this setting, but in situations where you have a very large number of simple components being rendered, and where they are guaranteed never to do any drawing beyond their own boundaries, setting this to true will reduce the overhead involved in clipping the graphics context that gets passed to the component's paint() callback. If you enable this mode, you'll need to make sure your paint method doesn't call anything like Graphics::fillAll(), and doesn't draw beyond the component's bounds, because that'll produce artifacts. Your component also can't have any child components that may be placed beyond its bounds.

## ◆ isPaintingUnclipped()

bool Component::isPaintingUnclipped | ( |  | ) | const
| noexcept

Returns true if this component doesn't require its graphics context to be clipped when it is being painted.

## ◆ setComponentEffect()

void Component::setComponentEffect | ( | ImageEffectFilter * | newEffect | ) |

Adds an effect filter to alter the component's appearance.

When a component has an effect filter set, then this is applied to the results of its paint() method. There are a few preset effects, such as a drop-shadow or glow, but they can be user-defined as well.

The effect that is passed in will not be deleted by the component - the caller must take care of deleting it.

To remove an effect from a component, pass a null pointer in as the parameter.

See also
  ImageEffectFilter, DropShadowEffect, GlowEffect

## ◆ getComponentEffect()

ImageEffectFilter* Component::getComponentEffect | ( |  | ) | const
| noexcept

Returns the current component effect.

See also
  setComponentEffect

## ◆ getLookAndFeel()

LookAndFeel& Component::getLookAndFeel | ( |  | ) | const
| noexcept

Finds the appropriate look-and-feel to use for this component.

If the component hasn't had a look-and-feel explicitly set, this will return the parent's look-and-feel, or just the default one if there's no parent.

See also
  setLookAndFeel, lookAndFeelChanged

Referenced by LassoComponent< SelectableItemType >::paint(), and StandalonePluginHolder::showAudioSettingsDialog().

## ◆ setLookAndFeel()

void Component::setLookAndFeel | ( | LookAndFeel * | newLookAndFeel | ) |

Sets the look and feel to use for this component.

This will also change the look and feel for any child components that haven't had their look set explicitly.

The object passed in will not be deleted by the component, so it's the caller's responsibility to manage it. It may be used at any time until this component has been deleted.

Calling this method will also invoke the sendLookAndFeelChange() method.

See also
  getLookAndFeel, lookAndFeelChanged

## ◆ lookAndFeelChanged()

virtual void Component::lookAndFeelChanged | ( |  | ) |
| virtual

Called to let the component react to a change in the look-and-feel setting.

When the look-and-feel is changed for a component, this will be called in all its child components, recursively.

It can also be triggered manually by the sendLookAndFeelChange() method, in case an application uses a LookAndFeel class that might have changed internally.

See also
  sendLookAndFeelChange, getLookAndFeel

Reimplemented in Slider, TextEditor, AlertWindow, ComboBox, ScrollBar, ResizableWindow, TabbedButtonBar, Viewport, FileBrowserComponent, FilenameComponent, TabbedComponent, ProgressBar, and OnlineUnlockForm.

## ◆ sendLookAndFeelChange()

void Component::sendLookAndFeelChange | ( |  | ) |

Calls the lookAndFeelChanged() method in this component and all its children.

This will recurse through the children and their children, calling lookAndFeelChanged() on them all.

See also
  lookAndFeelChanged

## ◆ setOpaque()

void Component::setOpaque | ( | bool | shouldBeOpaque | ) |

Indicates whether any parts of the component might be transparent.

Components that always paint all of their contents with solid colour and thus completely cover any components behind them should use this method to tell the repaint system that they are opaque.

This information is used to optimise drawing, because it means that objects underneath opaque windows don't need to be painted.

By default, components are considered transparent, unless this is used to make it otherwise.

See also
  isOpaque

## ◆ isOpaque()

bool Component::isOpaque | ( |  | ) | const
| noexcept

Returns true if no parts of this component are transparent.

Returns
  the value that was set by setOpaque, (the default being false)

See also
  setOpaque

## ◆ setBroughtToFrontOnMouseClick()

void Component::setBroughtToFrontOnMouseClick | ( | bool | shouldBeBroughtToFront | ) |
| noexcept

Indicates whether the component should be brought to the front when clicked.

Setting this flag to true will cause the component to be brought to the front when the mouse is clicked somewhere inside it or its child components.

Note that a top-level desktop window might still be brought to the front by the operating system when it's clicked, depending on how the OS works.

By default this is set to false.

See also
  setMouseClickGrabsKeyboardFocus

## ◆ isBroughtToFrontOnMouseClick()

bool Component::isBroughtToFrontOnMouseClick | ( |  | ) | const
| noexcept

Indicates whether the component should be brought to the front when clicked-on.

See also
  setBroughtToFrontOnMouseClick

## ◆ setWantsKeyboardFocus()

void Component::setWantsKeyboardFocus | ( | bool | wantsFocus | ) |
| noexcept

Sets a flag to indicate whether this component needs keyboard focus or not.

By default components aren't actually interested in gaining the focus, but this method can be used to turn this on.

See the grabKeyboardFocus() method for details about the way a component is chosen to receive the focus.

See also
  grabKeyboardFocus, getWantsKeyboardFocus

## ◆ getWantsKeyboardFocus()

bool Component::getWantsKeyboardFocus | ( |  | ) | const
| noexcept

Returns true if the component is interested in getting keyboard focus.

This returns the flag set by setWantsKeyboardFocus(). The default setting is false.

See also
  setWantsKeyboardFocus

## ◆ setMouseClickGrabsKeyboardFocus()

void Component::setMouseClickGrabsKeyboardFocus | ( | bool | shouldGrabFocus | ) |

Chooses whether a click on this component automatically grabs the focus.

By default this is set to true, but you might want a component which can be focused, but where you don't want the user to be able to affect it directly by clicking.

## ◆ getMouseClickGrabsKeyboardFocus()

bool Component::getMouseClickGrabsKeyboardFocus | ( |  | ) | const
| noexcept

Returns the last value set with setMouseClickGrabsKeyboardFocus().

See setMouseClickGrabsKeyboardFocus() for more info.

## ◆ grabKeyboardFocus()

void Component::grabKeyboardFocus | ( |  | ) |

Tries to give keyboard focus to this component.

When the user clicks on a component or its grabKeyboardFocus() method is called, the following procedure is used to work out which component should get it:

- if the component that was clicked on actually wants focus (as indicated by calling getWantsKeyboardFocus), it gets it.
- if the component itself doesn't want focus, it will try to pass it on to whichever of its children is the default component, as determined by KeyboardFocusTraverser::getDefaultComponent()
- if none of its children want focus at all, it will pass it up to its parent instead, unless it's a top-level component without a parent, in which case it just takes the focus itself.

Important note! It's obviously not possible for a component to be focused unless it's actually visible, on-screen, and inside a window that is also visible. So there's no point trying to call this in the component's own constructor or before all of its parent hierarchy has been fully instantiated.

See also
  setWantsKeyboardFocus, getWantsKeyboardFocus, hasKeyboardFocus, getCurrentlyFocusedComponent, focusGained, focusLost, keyPressed, keyStateChanged

## ◆ hasKeyboardFocus()

bool Component::hasKeyboardFocus | ( | bool | trueIfChildIsFocused | ) | const

Returns true if this component currently has the keyboard focus.

Parameters

  trueIfChildIsFocused | if this is true, then the method returns true if either this component or any of its children (recursively) have the focus. If false, the method only returns true if this component has the focus.

See also
  grabKeyboardFocus, setWantsKeyboardFocus, getCurrentlyFocusedComponent, focusGained, focusLost

## ◆ getCurrentlyFocusedComponent()

static Component* JUCE_CALLTYPE Component::getCurrentlyFocusedComponent | ( |  | ) |
| staticnoexcept

Returns the component that currently has the keyboard focus.

Returns
  the focused component, or null if nothing is focused.

## ◆ unfocusAllComponents()

static void JUCE_CALLTYPE Component::unfocusAllComponents | ( |  | ) |
| static

If any component has keyboard focus, this will defocus it.

## ◆ moveKeyboardFocusToSibling()

void Component::moveKeyboardFocusToSibling | ( | bool | moveToNext | ) |

Tries to move the keyboard focus to one of this component's siblings.

This will try to move focus to either the next or previous component. (This is the method that is used when shifting focus by pressing the tab key).

Components for which getWantsKeyboardFocus() returns false are not looked at.

Parameters

  moveToNext | if true, the focus will move forwards; if false, it will move backwards

See also
  grabKeyboardFocus, setFocusContainer, setWantsKeyboardFocus

## ◆ createFocusTraverser()

virtual KeyboardFocusTraverser* Component::createFocusTraverser | ( |  | ) |
| virtual

Creates a KeyboardFocusTraverser object to use to determine the logic by which focus should be passed from this component.

The default implementation of this method will return a default KeyboardFocusTraverser if this component is a focus container (as determined by the setFocusContainer() method). If the component isn't a focus container, then it will recursively ask its parents for a KeyboardFocusTraverser.

If you override this to return a custom KeyboardFocusTraverser, then this component and all its sub-components will use the new object to make their focusing decisions.

The method should return a new object, which the caller is required to delete when no longer needed.

Reimplemented in Label, and FilenameComponent.

## ◆ getExplicitFocusOrder()

int Component::getExplicitFocusOrder | ( |  | ) | const

Returns the focus order of this component, if one has been specified.

By default components don't have a focus order - in that case, this will return 0. Lower numbers indicate that the component will be earlier in the focus traversal order.

To change the order, call setExplicitFocusOrder().

The focus order may be used by the KeyboardFocusTraverser class as part of its algorithm for deciding the order in which components should be traversed. See the KeyboardFocusTraverser class for more details on this.

See also
  moveKeyboardFocusToSibling, createFocusTraverser, KeyboardFocusTraverser

## ◆ setExplicitFocusOrder()

void Component::setExplicitFocusOrder | ( | int | newFocusOrderIndex | ) |

Sets the index used in determining the order in which focusable components should be traversed.

A value of 0 or less is taken to mean that no explicit order is wanted, and that traversal should use other factors, like the component's position.

See also
  getExplicitFocusOrder, moveKeyboardFocusToSibling

## ◆ setFocusContainer()

void Component::setFocusContainer | ( | bool | shouldBeFocusContainer | ) |
| noexcept

Indicates whether this component is a parent for components that can have their focus traversed.

This flag is used by the default implementation of the createFocusTraverser() method, which uses the flag to find the first parent component (of the currently focused one) which wants to be a focus container.

So using this method to set the flag to 'true' causes this component to act as the top level within which focus is passed around.

See also
  isFocusContainer, createFocusTraverser, moveKeyboardFocusToSibling

## ◆ isFocusContainer()

bool Component::isFocusContainer | ( |  | ) | const
| noexcept

Returns true if this component has been marked as a focus container.

See setFocusContainer() for more details.

See also
  setFocusContainer, moveKeyboardFocusToSibling, createFocusTraverser

## ◆ isEnabled()

bool Component::isEnabled | ( |  | ) | const
| noexcept

Returns true if the component (and all its parents) are enabled.

Components are enabled by default, and can be disabled with setEnabled(). Exactly what difference this makes to the component depends on the type. E.g. buttons and sliders will choose to draw themselves differently, etc.

Note that if one of this component's parents is disabled, this will always return false, even if this component itself is enabled.

See also
  setEnabled, enablementChanged

## ◆ setEnabled()

void Component::setEnabled | ( | bool | shouldBeEnabled | ) |

Enables or disables this component.

Disabling a component will also cause all of its child components to become disabled.

Similarly, enabling a component which is inside a disabled parent component won't make any difference until the parent is re-enabled.

See also
  isEnabled, enablementChanged

## ◆ enablementChanged()

virtual void Component::enablementChanged | ( |  | ) |
| virtual

Callback to indicate that this component has been enabled or disabled.

This can be triggered by one of the component's parent components being enabled or disabled, as well as changes to the component itself.

The default implementation of this method does nothing; your class may wish to repaint itself or something when this happens.

See also
  setEnabled, isEnabled

Reimplemented in Slider, TreeView, TextEditor, Button, ComboBox, Label, DrawableButton, PropertyComponent, GroupComponent, and ToolbarButton.

## ◆ getAlpha()

float Component::getAlpha | ( |  | ) | const
| noexcept

Returns the component's current transparancy level.

See setAlpha() for more details.

## ◆ setAlpha()

void Component::setAlpha | ( | float | newAlpha | ) |

Changes the transparency of this component.

When painted, the entire component and all its children will be rendered with this as the overall opacity level, where 0 is completely invisible, and 1.0 is fully opaque (i.e. normal).

See also
  getAlpha, alphaChanged

## ◆ alphaChanged()

virtual void Component::alphaChanged | ( |  | ) |
| virtual

Called when setAlpha() is used to change the alpha value of this component.

If you override this, you should also invoke the base class's implementation during your overridden function, as it performs some repainting behaviour.

Reimplemented in NSViewComponent.

## ◆ setMouseCursor()

void Component::setMouseCursor | ( | const MouseCursor & | cursorType | ) |

Changes the mouse cursor shape to use when the mouse is over this component.

Note that the cursor set by this method can be overridden by the getMouseCursor method.

See also
  MouseCursor

## ◆ getMouseCursor()

virtual MouseCursor Component::getMouseCursor | ( |  | ) |
| virtual

Returns the mouse cursor shape to use when the mouse is over this component.

The default implementation will return the cursor that was set by setCursor() but can be overridden for more specialised purposes, e.g. returning different cursors depending on the mouse position.

See also
  MouseCursor

Reimplemented in TableHeaderComponent.

## ◆ updateMouseCursor()

void Component::updateMouseCursor | ( |  | ) | const

Forces the current mouse cursor to be updated.

If you're overriding the getMouseCursor() method to control which cursor is displayed, then this will only be checked each time the user moves the mouse. So if you want to force the system to check that the cursor being displayed is up-to-date (even if the mouse is just sitting there), call this method.

(If you're changing the cursor using setMouseCursor(), you don't need to bother calling this).

## ◆ paint()

virtual void Component::paint | ( | Graphics & | g | ) |
| virtual

Components can override this method to draw their content.

The paint() method gets called when a region of a component needs redrawing, either because the component's repaint() method has been called, or because something has happened on the screen that means a section of a window needs to be redrawn.

Any child components will draw themselves over whatever this method draws. If you need to paint over the top of your child components, you can also implement the paintOverChildren() method to do this.

If you want to cause a component to redraw itself, this is done asynchronously - calling the repaint() method marks a region of the component as "dirty", and the paint() method will automatically be called sometime later, by the message thread, to paint any bits that need refreshing. In JUCE (and almost all modern UI frameworks), you never redraw something synchronously.

You should never need to call this method directly - to take a snapshot of the component you could use createComponentSnapshot() or paintEntireComponent().

Parameters

  g | the graphics context that must be used to do the drawing operations.

See also
  repaint, paintOverChildren, Graphics

Reimplemented in LassoComponent< SelectableItemType >, SidePanel, MultiChoicePropertyComponent, Slider, TreeView, TextEditor, ListBox, Button, AlertWindow, ComboBox, ScrollBar, TableHeaderComponent, CodeEditorComponent, ResizableWindow, TabbedButtonBar, Label, Toolbar, MidiKeyboardComponent, MultiDocumentPanel, TabbedComponent, BubbleComponent, ResizableBorderComponent, PropertyPanel, CallOutBox, SplashScreen, PreferencesPanel, WebBrowserComponent, ProgressBar, AudioVisualiserComponent, ActiveXControlComponent, XEmbedComponent, DrawableShape, BooleanPropertyComponent, PropertyComponent, GroupComponent, SystemTrayIconComponent, FileSearchPathListComponent, DrawableText, StretchableLayoutResizerBar, DrawableImage, ResizableEdgeComponent, NSViewComponent, UIViewComponent, MenuBarComponent, ResizableCornerComponent, OnlineUnlockForm, CaretComponent, ImageComponent, AndroidViewComponent, ImagePreviewComponent, and GenericAudioProcessorEditor.

## ◆ paintOverChildren()

virtual void Component::paintOverChildren | ( | Graphics & | g | ) |
| virtual

Components can override this method to draw over the top of their children.

For most drawing operations, it's better to use the normal paint() method, but if you need to overlay something on top of the children, this can be used.

See also
  paint, Graphics

Reimplemented in TextEditor, ListBox, and FilenameComponent.

## ◆ mouseMove()

void Component::mouseMove | ( | const MouseEvent & | event | ) |
| overridevirtual

Called when the mouse moves inside a component.

If the mouse button isn't pressed and the mouse moves over a component, this will be called to let the component react to this.

A component will always get a mouseEnter callback before a mouseMove.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseEnter, mouseExit, mouseDrag, contains

Reimplemented from MouseListener.

Reimplemented in Slider, TableHeaderComponent, ResizableBorderComponent, and MenuBarComponent.

## ◆ mouseEnter()

void Component::mouseEnter | ( | const MouseEvent & | event | ) |
| overridevirtual

Called when the mouse first enters a component.

If the mouse button isn't pressed and the mouse moves into a component, this will be called to let the component react to this.

When the mouse button is pressed and held down while being moved in or out of a component, no mouseEnter or mouseExit callbacks are made - only mouseDrag messages are sent to the component that the mouse was originally clicked on, until the button is released.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseExit, mouseDrag, mouseMove, contains

Reimplemented from MouseListener.

Reimplemented in Slider, TableHeaderComponent, ResizableBorderComponent, and MenuBarComponent.

## ◆ mouseExit()

void Component::mouseExit | ( | const MouseEvent & | event | ) |
| overridevirtual

Called when the mouse moves out of a component.

This will be called when the mouse moves off the edge of this component.

If the mouse button was pressed, and it was then dragged off the edge of the component and released, then this callback will happen when the button is released, after the mouseUp callback.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseEnter, mouseDrag, mouseMove, contains

Reimplemented from MouseListener.

Reimplemented in Slider, TableHeaderComponent, and MenuBarComponent.

## ◆ mouseDown()

void Component::mouseDown | ( | const MouseEvent & | event | ) |
| overridevirtual

Called when a mouse button is pressed.

The MouseEvent object passed in contains lots of methods for finding out which button was pressed, as well as which modifier keys (e.g. shift, ctrl) were held down at the time.

Once a button is held down, the mouseDrag method will be called when the mouse moves, until the button is released.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseUp, mouseDrag, mouseDoubleClick, contains

Reimplemented from MouseListener.

Reimplemented in Slider, TextEditor, AlertWindow, TableHeaderComponent, ScrollBar, ComboBox, CodeEditorComponent, ResizableWindow, Toolbar, ResizableBorderComponent, StretchableLayoutResizerBar, ResizableEdgeComponent, MenuBarComponent, and ResizableCornerComponent.

## ◆ mouseDrag()

void Component::mouseDrag | ( | const MouseEvent & | event | ) |
| overridevirtual

Called when the mouse is moved while a button is held down.

When a mouse button is pressed inside a component, that component receives mouseDrag callbacks each time the mouse moves, even if the mouse strays outside the component's bounds.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseDown, mouseUp, mouseMove, contains, setDragRepeatInterval

Reimplemented from MouseListener.

Reimplemented in Slider, TextEditor, AlertWindow, TableHeaderComponent, ScrollBar, ComboBox, CodeEditorComponent, ResizableWindow, ResizableBorderComponent, SidePanel, StretchableLayoutResizerBar, ResizableEdgeComponent, MenuBarComponent, and ResizableCornerComponent.

## ◆ mouseUp()

void Component::mouseUp | ( | const MouseEvent & | event | ) |
| overridevirtual

Called when a mouse button is released.

A mouseUp callback is sent to the component in which a button was pressed even if the mouse is actually over a different component when the button is released.

The MouseEvent object passed in contains lots of methods for finding out which buttons were down just before they were released.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseDown, mouseDrag, mouseDoubleClick, contains

Reimplemented from MouseListener.

Reimplemented in Slider, TextEditor, ListBox, TableHeaderComponent, ScrollBar, ComboBox, CodeEditorComponent, ResizableWindow, Label, ResizableBorderComponent, SidePanel, ResizableEdgeComponent, MenuBarComponent, and ResizableCornerComponent.

## ◆ mouseDoubleClick()

void Component::mouseDoubleClick | ( | const MouseEvent & | event | ) |
| overridevirtual

Called when a mouse button has been double-clicked on a component.

The MouseEvent object passed in contains lots of methods for finding out which button was pressed, as well as which modifier keys (e.g. shift, ctrl) were held down at the time.

Parameters

  event | details about the position and status of the mouse event, including the source component in which it occurred

See also
  mouseDown, mouseUp

Reimplemented from MouseListener.

Reimplemented in Slider, TextEditor, CodeEditorComponent, and Label.

## ◆ mouseWheelMove()

void Component::mouseWheelMove | ( | const MouseEvent & | event,
|  | const MouseWheelDetails & | wheel
| ) |  |
| overridevirtual

Called when the mouse-wheel is moved.

This callback is sent to the component that the mouse is over when the wheel is moved.

If not overridden, a component will forward this message to its parent, so that parent components can collect mouse-wheel messages that happen to child components which aren't interested in them. (Bear in mind that if you attach a component as a mouse-listener to other components, then those wheel moves will also end up calling this method and being passed up to the parents, which may not be what you intended to happen).

Parameters

  event | details about the mouse event
  wheel | details about the mouse wheel movement

Reimplemented from MouseListener.

Reimplemented in Slider, TextEditor, ListBox, ComboBox, ScrollBar, CodeEditorComponent, and Viewport.

## ◆ mouseMagnify()

void Component::mouseMagnify | ( | const MouseEvent & | event,
|  | float | scaleFactor
| ) |  |
| overridevirtual

Called when a pinch-to-zoom mouse-gesture is used.

If not overridden, a component will forward this message to its parent, so that parent components can collect gesture messages that are unused by child components.

Parameters

  event | details about the mouse event
  scaleFactor | a multiplier to indicate by how much the size of the target should be changed. A value of 1.0 would indicate no change, values greater than 1.0 mean it should be enlarged.

Reimplemented from MouseListener.

## ◆ beginDragAutoRepeat()

static void JUCE_CALLTYPE Component::beginDragAutoRepeat | ( | int | millisecondsBetweenCallbacks | ) |
| static

Ensures that a non-stop stream of mouse-drag events will be sent during the current mouse-drag operation.

This allows you to make sure that mouseDrag() events are sent continuously, even when the mouse isn't moving. This can be useful for things like auto-scrolling components when the mouse is near an edge.

Call this method during a mouseDown() or mouseDrag() callback, specifying the minimum interval between consecutive mouse drag callbacks. The callbacks will continue until the mouse is released, and then the interval will be reset, so you need to make sure it's called every time you begin a drag event. Passing an interval of 0 or less will cancel the auto-repeat.

See also
  mouseDrag, Desktop::beginDragAutoRepeat

## ◆ setRepaintsOnMouseActivity()

void Component::setRepaintsOnMouseActivity | ( | bool | shouldRepaint | ) |
| noexcept

Causes automatic repaints when the mouse enters or exits this component.

If turned on, then when the mouse enters/exits, or when the button is pressed/released on the component, it will trigger a repaint.

This is handy for things like buttons that need to draw themselves differently when the mouse moves over them, and it avoids having to override all the different mouse callbacks and call repaint().

See also
  mouseEnter, mouseExit, mouseDown, mouseUp

## ◆ addMouseListener()

void Component::addMouseListener | ( | MouseListener * | newListener,
|  | bool | wantsEventsForAllNestedChildComponents
| ) |  |

Registers a listener to be told when mouse events occur in this component.

If you need to get informed about mouse events in a component but can't or don't want to override its methods, you can attach any number of listeners to the component, and these will get told about the events in addition to the component's own callbacks being called.

Note that a MouseListener can also be attached to more than one component.

Parameters

  newListener | the listener to register
  wantsEventsForAllNestedChildComponents | if true, the listener will receive callbacks for events that happen to any child component within this component, including deeply-nested child components. If false, it will only be told about events that this component handles.

See also
  MouseListener, removeMouseListener

## ◆ removeMouseListener()

void Component::removeMouseListener | ( | MouseListener * | listenerToRemove | ) |

Deregisters a mouse listener.

See also
  addMouseListener, MouseListener

## ◆ addKeyListener()

void Component::addKeyListener | ( | KeyListener * | newListener | ) |

Adds a listener that wants to hear about keypresses that this component receives.

The listeners that are registered with a component are called by its keyPressed() or keyStateChanged() methods (assuming these haven't been overridden to do something else).

If you add an object as a key listener, be careful to remove it when the object is deleted, or the component will be left with a dangling pointer.

See also
  keyPressed, keyStateChanged, removeKeyListener

## ◆ removeKeyListener()

void Component::removeKeyListener | ( | KeyListener * | listenerToRemove | ) |

Removes a previously-registered key listener.

See also
  addKeyListener

## ◆ keyPressed()

virtual bool Component::keyPressed | ( | const KeyPress & | key | ) |
| virtual

Called when a key is pressed.

When a key is pressed, the component that has the keyboard focus will have this method called. Remember that a component will only be given the focus if its setWantsKeyboardFocus() method has been used to enable this.

If your implementation returns true, the event will be consumed and not passed on to any other listeners. If it returns false, the key will be passed to any KeyListeners that have been registered with this component. As soon as one of these returns true, the process will stop, but if they all return false, the event will be passed upwards to this component's parent, and so on.

The default implementation of this method does nothing and returns false.

See also
  keyStateChanged, getCurrentlyFocusedComponent, addKeyListener

Reimplemented in TreeView, TextEditor, ListBox, Button, AlertWindow, ComboBox, ScrollBar, CodeEditorComponent, MidiKeyboardComponent, Viewport, DialogWindow, FileBrowserComponent, CallOutBox, and MenuBarComponent.

## ◆ keyStateChanged()

virtual bool Component::keyStateChanged | ( | bool | isKeyDown | ) |
| virtual

Called when a key is pressed or released.

Whenever a key on the keyboard is pressed or released (including modifier keys like shift and ctrl), this method will be called on the component that currently has the keyboard focus. Remember that a component will only be given the focus if its setWantsKeyboardFocus() method has been used to enable this.

If your implementation returns true, the event will be consumed and not passed on to any other listeners. If it returns false, then any KeyListeners that have been registered with this component will have their keyStateChanged methods called. As soon as one of these returns true, the process will stop, but if they all return false, the event will be passed upwards to this component's parent, and so on.

The default implementation of this method does nothing and returns false.

To find out which keys are up or down at any time, see the KeyPress::isKeyCurrentlyDown() method.

Parameters

  isKeyDown | true if a key has been pressed; false if it has been released

See also
  keyPressed, KeyPress, getCurrentlyFocusedComponent, addKeyListener

Reimplemented in TextEditor, ComboBox, ListBox, and MidiKeyboardComponent.

## ◆ modifierKeysChanged()

virtual void Component::modifierKeysChanged | ( | const ModifierKeys & | modifiers | ) |
| virtual

Called when a modifier key is pressed or released.

Whenever the shift, control, alt or command keys are pressed or released, this method will be called on the component that currently has the keyboard focus. Remember that a component will only be given the focus if its setWantsKeyboardFocus() method has been used to enable this.

The default implementation of this method actually calls its parent's modifierKeysChanged method, so that focused components which aren't interested in this will give their parents a chance to act on the event instead.

See also
  keyStateChanged, ModifierKeys

Reimplemented in Slider.

## ◆ focusGained()

virtual void Component::focusGained | ( | FocusChangeType | cause | ) |
| virtual

Called to indicate that this component has just acquired the keyboard focus.

See also
  focusLost, setWantsKeyboardFocus, getCurrentlyFocusedComponent, hasKeyboardFocus

Reimplemented in TextEditor, Button, CodeEditorComponent, Label, WebBrowserComponent, XEmbedComponent, and ComboBox.

## ◆ focusLost()

virtual void Component::focusLost | ( | FocusChangeType | cause | ) |
| virtual

Called to indicate that this component has just lost the keyboard focus.

See also
  focusGained, setWantsKeyboardFocus, getCurrentlyFocusedComponent, hasKeyboardFocus

Reimplemented in TextEditor, Button, CodeEditorComponent, MidiKeyboardComponent, XEmbedComponent, and ComboBox.

## ◆ focusOfChildComponentChanged()

virtual void Component::focusOfChildComponentChanged | ( | FocusChangeType | cause | ) |
| virtual

Called to indicate a change in whether or not this component is the parent of the currently-focused component.

Essentially this is called when the return value of a call to hasKeyboardFocus (true) has changed. It happens when focus moves from one of this component's children (at any depth) to a component that isn't contained in this one, (or vice-versa). Note that this method does NOT get called to when focus simply moves from one of its child components to another.

See also
  focusGained, setWantsKeyboardFocus, getCurrentlyFocusedComponent, hasKeyboardFocus

Reimplemented in Slider, and TopLevelWindow.

## ◆ isMouseOver()

bool Component::isMouseOver | ( | bool | includeChildren = `false` | ) | const

Returns true if the mouse is currently over this component.

If the mouse isn't over the component, this will return false, even if the mouse is currently being dragged - so you can use this in your mouseDrag method to find out whether it's really over the component or not.

Note that when the mouse button is being held down, then the only component for which this method will return true is the one that was originally clicked on.

Also note that on a touch-screen device, this will only return true when a finger is actually down - as soon as all touch is released, isMouseOver will always return false.

If includeChildren is true, then this will also return true if the mouse is over any of the component's children (recursively) as well as the component itself.

See also
  isMouseButtonDown. isMouseOverOrDragging, mouseDrag

## ◆ isMouseButtonDown()

bool Component::isMouseButtonDown | ( | bool | includeChildren = `false` | ) | const

Returns true if the mouse button is currently held down in this component.

Note that this is a test to see whether the mouse is being pressed in this component, so it'll return false if called on component A when the mouse is actually being dragged in component B.

See also
  isMouseButtonDownAnywhere, isMouseOver, isMouseOverOrDragging

## ◆ isMouseOverOrDragging()

bool Component::isMouseOverOrDragging | ( | bool | includeChildren = `false` | ) | const

True if the mouse is over this component, or if it's being dragged in this component.

This is a handy equivalent to (isMouseOver() || isMouseButtonDown()).

See also
  isMouseOver, isMouseButtonDown, isMouseButtonDownAnywhere

## ◆ isMouseButtonDownAnywhere()

static bool JUCE_CALLTYPE Component::isMouseButtonDownAnywhere | ( |  | ) |
| staticnoexcept

Returns true if a mouse button is currently down.

Unlike isMouseButtonDown, this will test the current state of the buttons without regard to which component (if any) it has been pressed in.

See also
  isMouseButtonDown, ModifierKeys

Referenced by LassoComponent< SelectableItemType >::paint().

## ◆ getMouseXYRelative()

Point<int> Component::getMouseXYRelative | ( |  | ) | const

Returns the mouse's current position, relative to this component.

The return value is relative to the component's top-left corner.

## ◆ resized()

virtual void Component::resized | ( |  | ) |
| virtual

Called when this component's size has been changed.

A component can implement this method to do things such as laying out its child components when its width or height changes.

The method is called synchronously as a result of the setBounds or setSize methods, so repeatedly changing a components size will repeatedly call its resized method (unlike things like repainting, where multiple calls to repaint are coalesced together).

If the component is a top-level window on the desktop, its size could also be changed by operating-system factors beyond the application's control.

See also
  moved, setSize

Reimplemented in Slider, TreeView, StandaloneFilterWindow, TextEditor, ListBox, ComboBox, ScrollBar, CodeEditorComponent, ResizableWindow, TabbedButtonBar, TableListBox, Label, Toolbar, MidiKeyboardComponent, Viewport, MultiDocumentPanel, DialogWindow, FileBrowserComponent, FilenameComponent, TabbedComponent, ToolbarItemComponent, DrawableButton, PropertyPanel, CallOutBox, SidePanel, PreferencesPanel, WebBrowserComponent, TabBarButton, KeyMappingEditorComponent, MultiChoicePropertyComponent, PropertyComponent, AudioDeviceSelectorComponent, FileSearchPathListComponent, ToolbarButton, MenuBarComponent, OnlineUnlockForm, ToolbarItemPalette, and GenericAudioProcessorEditor.

## ◆ moved()

virtual void Component::moved | ( |  | ) |
| virtual

Called when this component's position has been changed.

This is called when the position relative to its parent changes, not when its absolute position on the screen changes (so it won't be called for all child components when a parent component is moved).

The method is called synchronously as a result of the setBounds, setTopLeftPosition or any of the other repositioning methods, and like resized(), it will be called each time those methods are called.

If the component is a top-level window on the desktop, its position could also be changed by operating-system factors beyond the application's control.

See also
  resized, setBounds

Reimplemented in ResizableWindow, CallOutBox, and SidePanel.

## ◆ childBoundsChanged()

virtual void Component::childBoundsChanged | ( | Component * | child | ) |
| virtual

Called when one of this component's children is moved or resized.

If the parent wants to know about changes to its immediate children (not to children of its children), this is the method to override.

See also
  moved, resized, parentSizeChanged

Reimplemented in ResizableWindow, CallOutBox, TabBarButton, and DrawableComposite.

## ◆ parentSizeChanged()

virtual void Component::parentSizeChanged | ( |  | ) |
| virtual

Called when this component's immediate parent has been resized.

If the component is a top-level window, this indicates that the screen size has changed.

See also
  childBoundsChanged, moved, resized

Reimplemented in ResizableWindow.

## ◆ broughtToFront()

virtual void Component::broughtToFront | ( |  | ) |
| virtual

Called when this component has been moved to the front of its siblings.

The component may have been brought to the front by the toFront() method, or by the operating system if it's a top-level window.

See also
  toFront

Reimplemented in XEmbedComponent, and MultiDocumentPanelWindow.

## ◆ addComponentListener()

void Component::addComponentListener | ( | ComponentListener * | newListener | ) |

Adds a listener to be told about changes to the component hierarchy or position.

Component listeners get called when this component's size, position or children change - see the ComponentListener class for more details.

Parameters

  newListener | the listener to register - if this is already registered, it will be ignored.

See also
  ComponentListener, removeComponentListener

## ◆ removeComponentListener()

void Component::removeComponentListener | ( | ComponentListener * | listenerToRemove | ) |

Removes a component listener.

See also
  addComponentListener

## ◆ postCommandMessage()

void Component::postCommandMessage | ( | int | commandId | ) |

Dispatches a numbered message to this component.

This is a quick and cheap way of allowing simple asynchronous messages to be sent to components. It's also safe, because if the component that you send the message to is a null or dangling pointer, this won't cause an error.

The command ID is later delivered to the component's handleCommandMessage() method by the application's message queue.

See also
  handleCommandMessage

## ◆ handleCommandMessage()

virtual void Component::handleCommandMessage | ( | int | commandId | ) |
| virtual

Called to handle a command that was sent by postCommandMessage().

This is called by the message thread when a command message arrives, and the component can override this method to process it in any way it needs to.

See also
  postCommandMessage

Reimplemented in CallOutBox, Button, and MenuBarComponent.

## ◆ runModalLoop()

int Component::runModalLoop | ( |  | ) |

Runs a component modally, waiting until the loop terminates.

This method first makes the component visible, brings it to the front and gives it the keyboard focus.

It then runs a loop, dispatching messages from the system message queue, but blocking all mouse or keyboard messages from reaching any components other than this one and its children.

This loop continues until the component's exitModalState() method is called (or the component is deleted), and then this method returns, returning the value passed into exitModalState().

Note that you SHOULD NEVER USE THIS METHOD! Modal loops are a dangerous construct because things that happen during the events that they dispatch could affect the state of objects which are currently in use somewhere on the stack, so when the loop finishes and the stack unwinds, horrible problems can occur. This is especially bad in plugins, where the host may choose to delete the plugin during runModalLoop(), so that when it returns, the entire DLL could have been unloaded from memory! Also, some OSes deliberately make it impossible to run modal loops (e.g. Android), so this method won't even exist on some platforms.

See also
  enterModalState, exitModalState, isCurrentlyModal, getCurrentlyModalComponent, isCurrentlyBlockedByAnotherModalComponent, ModalComponentManager

## ◆ enterModalState()

void Component::enterModalState | ( | bool | takeKeyboardFocus = `true`,
|  | ModalComponentManager::Callback * | callback = `nullptr`,
|  | bool | deleteWhenDismissed = `false`
| ) |  |

Puts the component into a modal state.

This makes the component modal, so that messages are blocked from reaching any components other than this one and its children, but unlike runModalLoop(), this method returns immediately.

If takeKeyboardFocus is true, the component will use grabKeyboardFocus() to get the focus, which is usually what you'll want it to do. If not, it will leave the focus unchanged.

The callback is an optional object which will receive a callback when the modal component loses its modal status, either by being hidden or when exitModalState() is called. If you pass an object in here, the system will take care of deleting it later, after making the callback

If deleteWhenDismissed is true, then when it is dismissed, the component will be deleted and then the callback will be called. (This will safely handle the situation where the component is deleted before its exitModalState() method is called).

See also
  exitModalState, runModalLoop, ModalComponentManager::attachCallback

## ◆ exitModalState()

void Component::exitModalState | ( | int | returnValue | ) |

Ends a component's modal state.

If this component is currently modal, this will turn off its modalness, and return a value to the runModalLoop() method that might have be running its modal loop.

See also
  runModalLoop, enterModalState, isCurrentlyModal

## ◆ isCurrentlyModal()

bool Component::isCurrentlyModal | ( | bool | onlyConsiderForemostModalComponent = `true` | ) | const
| noexcept

Returns true if this component is the modal one.

It's possible to have nested modal components, e.g. a pop-up dialog box that launches another pop-up. If onlyConsiderForemostModalComponent is true then isCurrentlyModal will only return true for the one at the top of the stack. If onlyConsiderForemostModalComponent is false then isCurrentlyModal will return true for any modal component in the stack.

See also
  getCurrentlyModalComponent

## ◆ getNumCurrentlyModalComponents()

static int JUCE_CALLTYPE Component::getNumCurrentlyModalComponents | ( |  | ) |
| staticnoexcept

Returns the number of components that are currently in a modal state.

See also
  getCurrentlyModalComponent

## ◆ getCurrentlyModalComponent()

static Component* JUCE_CALLTYPE Component::getCurrentlyModalComponent | ( | int | index = `0` | ) |
| staticnoexcept

Returns one of the components that are currently modal.

The index specifies which of the possible modal components to return. The order of the components in this list is the reverse of the order in which they became modal - so the component at index 0 is always the active component, and the others are progressively earlier ones that are themselves now blocked by later ones.

Returns
  the modal component, or null if no components are modal (or if the index is out of range)

See also
  getNumCurrentlyModalComponents, runModalLoop, isCurrentlyModal

## ◆ isCurrentlyBlockedByAnotherModalComponent()

bool Component::isCurrentlyBlockedByAnotherModalComponent | ( |  | ) | const

Checks whether there's a modal component somewhere that's stopping this one from receiving messages.

If there is a modal component, its canModalEventBeSentToComponent() method will be called to see if it will still allow this component to receive events.

See also
  runModalLoop, getCurrentlyModalComponent

## ◆ canModalEventBeSentToComponent()

virtual bool Component::canModalEventBeSentToComponent | ( | const Component * | targetComponent | ) |
| virtual

When a component is modal, this callback allows it to choose which other components can still receive events.

When a modal component is active and the user clicks on a non-modal component, this method is called on the modal component, and if it returns true, the event is allowed to reach its target. If it returns false, the event is blocked and the inputAttemptWhenModal() callback is made.

It called by the isCurrentlyBlockedByAnotherModalComponent() method. The default implementation just returns false in all cases.

## ◆ inputAttemptWhenModal()

virtual void Component::inputAttemptWhenModal | ( |  | ) |
| virtual

Called when the user tries to click on a component that is blocked by another modal component.

When a component is modal and the user clicks on one of the other components, the modal component will receive this callback.

The default implementation of this method will play a beep, and bring the currently modal component to the front, but it can be overridden to do other tasks.

See also
  isCurrentlyBlockedByAnotherModalComponent, canModalEventBeSentToComponent

Reimplemented in Label, and CallOutBox.

## ◆ getProperties() [1/2]

NamedValueSet& Component::getProperties | ( |  | ) |
| noexcept

Returns the set of properties that belong to this component.

Each component has a NamedValueSet object which you can use to attach arbitrary items of data to it.

## ◆ getProperties() [2/2]

const NamedValueSet& Component::getProperties | ( |  | ) | const
| noexcept

Returns the set of properties that belong to this component.

Each component has a NamedValueSet object which you can use to attach arbitrary items of data to it.

## ◆ findColour()

Colour Component::findColour | ( | int | colourID,
|  | bool | inheritFromParent = `false`
| ) |  | const

Looks for a colour that has been registered with the given colour ID number.

If a colour has been set for this ID number using setColour(), then it is returned. If none has been set, the method will try calling the component's LookAndFeel class's findColour() method. If none has been registered with the look-and-feel either, it will just return black.

The colour IDs for various purposes are stored as enums in the components that they are relevant to - for an example, see Slider::ColourIds, Label::ColourIds, TextEditor::ColourIds, TreeView::ColourIds, etc.

See also
  setColour, isColourSpecified, colourChanged, LookAndFeel::findColour, LookAndFeel::setColour

## ◆ setColour()

void Component::setColour | ( | int | colourID,
|  | Colour | newColour
| ) |  |

Registers a colour to be used for a particular purpose.

Changing a colour will cause a synchronous callback to the colourChanged() method, which your component can override if it needs to do something when colours are altered.

For more details about colour IDs, see the comments for findColour().

See also
  findColour, isColourSpecified, colourChanged, LookAndFeel::findColour, LookAndFeel::setColour

## ◆ removeColour()

void Component::removeColour | ( | int | colourID | ) |

If a colour has been set with setColour(), this will remove it.

This allows you to make a colour revert to its default state.

## ◆ isColourSpecified()

bool Component::isColourSpecified | ( | int | colourID | ) | const

Returns true if the specified colour ID has been explicitly set for this component using the setColour() method.

## ◆ copyAllExplicitColoursTo()

void Component::copyAllExplicitColoursTo | ( | Component & | target | ) | const

This looks for any colours that have been specified for this component, and copies them to the specified target component.

## ◆ colourChanged()

virtual void Component::colourChanged | ( |  | ) |
| virtual

This method is called when a colour is changed by the setColour() method.

See also
  setColour, findColour

Reimplemented in Slider, TreeView, ListBox, ComboBox, Label, MidiKeyboardComponent, DrawableButton, ProgressBar, TextPropertyComponent, HyperlinkButton, TextButton, GroupComponent, and ToggleButton.

## ◆ getWindowHandle()

void* Component::getWindowHandle | ( |  | ) | const

Returns the underlying native window handle for this component.

This is platform-dependent and strictly for power-users only!

## ◆ getPositioner()

Positioner* Component::getPositioner | ( |  | ) | const
| noexcept

Returns the Positioner object that has been set for this component.

See also
  setPositioner()

## ◆ setPositioner()

void Component::setPositioner | ( | Positioner * | newPositioner | ) |

Sets a new Positioner object for this component.

If there's currently another positioner set, it will be deleted. The object that is passed in will be deleted automatically by this component when it's no longer required. Pass a null pointer to clear the current positioner.

See also
  getPositioner()

## ◆ setCachedComponentImage()

void Component::setCachedComponentImage | ( | CachedComponentImage * | newCachedImage | ) |

Gives the component a CachedComponentImage that should be used to buffer its painting.

The object that is passed-in will be owned by this component, and will be deleted automatically later on.

See also
  setBufferedToImage

## ◆ getCachedComponentImage()

CachedComponentImage* Component::getCachedComponentImage | ( |  | ) | const
| noexcept

Returns the object that was set by setCachedComponentImage().

See also
  setCachedComponentImage

## ◆ setViewportIgnoreDragFlag()

void Component::setViewportIgnoreDragFlag | ( | bool | ignoreDrag | ) |
| noexcept

Sets a flag to indicate whether mouse drag events on this Component should be ignored when it is inside a Viewport with drag-to-scroll functionality enabled.

This is useful for Components such as sliders that should not move when their parent Viewport when dragged.

## ◆ getViewportIgnoreDragFlag()

bool Component::getViewportIgnoreDragFlag | ( |  | ) | const
| noexcept

Retrieves the current state of the Viewport drag-to-scroll functionality flag.

See also
  setViewportIgnoreDragFlag

The documentation for this class was generated from the following file:

- juce_Component.h